summaryrefslogtreecommitdiff
path: root/plugins
diff options
context:
space:
mode:
Diffstat (limited to 'plugins')
-rw-r--r--plugins/ant/ant.plugin.zsh26
-rw-r--r--plugins/archlinux/archlinux.plugin.zsh76
-rw-r--r--plugins/autojump/autojump.plugin.zsh3
-rw-r--r--plugins/brew/_brew24
-rw-r--r--plugins/brew/brew.plugin.zsh1
-rw-r--r--plugins/bundler/bundler.plugin.zsh34
-rw-r--r--plugins/cake/cake.plugin.zsh32
-rw-r--r--plugins/cap/cap.plugin.zsh2
-rw-r--r--plugins/cloudapp/cloudapp.plugin.zsh2
-rwxr-xr-xplugins/cloudapp/cloudapp.rb60
-rw-r--r--plugins/compleat/compleat.plugin.zsh2
-rw-r--r--plugins/django/django.plugin.zsh222
-rw-r--r--plugins/extract/_extract8
-rw-r--r--plugins/extract/extract.plugin.zsh85
-rw-r--r--plugins/gas/_gas34
-rw-r--r--plugins/git/git.plugin.zsh8
-rw-r--r--plugins/github/github.plugin.zsh1
-rw-r--r--plugins/gpg-agent/gpg-agent.plugin.zsh26
-rw-r--r--plugins/heroku/_heroku158
-rw-r--r--plugins/history-substring-search/README7
-rw-r--r--plugins/history-substring-search/history-substring-search.plugin.zsh12
-rw-r--r--plugins/history-substring-search/history-substring-search.zsh642
-rw-r--r--plugins/kate/kate.plugin.zsh9
-rw-r--r--plugins/knife/_knife174
-rw-r--r--plugins/lol/lol.plugin.zsh11
-rw-r--r--plugins/node/node.plugin.zsh5
-rw-r--r--plugins/npm/_npm19
-rw-r--r--plugins/npm/npm.plugin.zsh1
-rw-r--r--plugins/osx/_man-preview5
-rw-r--r--plugins/osx/osx.plugin.zsh130
-rw-r--r--plugins/phing/phing.plugin.zsh1
-rw-r--r--plugins/pow/pow.plugin.zsh10
-rw-r--r--plugins/powder/_powder4
-rw-r--r--plugins/python/python.plugin.zsh5
-rw-r--r--plugins/rails3/rails3.plugin.zsh11
-rw-r--r--plugins/redis-cli/_redis-cli2
-rw-r--r--plugins/ruby/ruby.plugin.zsh4
-rw-r--r--plugins/rvm/_rvm147
-rw-r--r--plugins/rvm/rvm.plugin.zsh44
-rw-r--r--plugins/ssh-agent/ssh-agent.plugin.zsh65
-rw-r--r--plugins/svn/svn.plugin.zsh12
-rw-r--r--plugins/taskwarrior/_task280
-rw-r--r--plugins/taskwarrior/taskwarrior.plugin.zsh21
-rw-r--r--plugins/textmate/textmate.plugin.zsh12
-rw-r--r--plugins/thor/_thor4
45 files changed, 2327 insertions, 114 deletions
diff --git a/plugins/ant/ant.plugin.zsh b/plugins/ant/ant.plugin.zsh
new file mode 100644
index 000000000..691d4d2db
--- /dev/null
+++ b/plugins/ant/ant.plugin.zsh
@@ -0,0 +1,26 @@
+stat -f%m . > /dev/null 2>&1
+if [ "$?" = 0 ]; then
+ stat_cmd=(stat -f%m)
+else
+ stat_cmd=(stat -L --format=%Y)
+fi
+
+_ant_does_target_list_need_generating () {
+ if [ ! -f .ant_targets ]; then return 0;
+ else
+ accurate=$($stat_cmd .ant_targets)
+ changed=$($stat_cmd build.xml)
+ return $(expr $accurate '>=' $changed)
+ fi
+}
+
+_ant () {
+ if [ -f build.xml ]; then
+ if _ant_does_target_list_need_generating; then
+ sed -n '/<target/s/<target.*name="\([^"]*\).*$/\1/p' build.xml > .ant_targets
+ fi
+ compadd `cat .ant_targets`
+ fi
+}
+
+compdef _ant ant
diff --git a/plugins/archlinux/archlinux.plugin.zsh b/plugins/archlinux/archlinux.plugin.zsh
new file mode 100644
index 000000000..b5e519036
--- /dev/null
+++ b/plugins/archlinux/archlinux.plugin.zsh
@@ -0,0 +1,76 @@
+# Archlinux zsh aliases and functions
+# Usage is also described at https://github.com/robbyrussell/oh-my-zsh/wiki/Plugins
+
+# Look for yaourt, and add some useful functions if we have it.
+if [[ -x `which yaourt` ]]; then
+ upgrade () {
+ yaourt -Syu
+ }
+ alias yaconf='yaourt -C' # Fix all configuration files with vimdiff
+ # Pacman - https://wiki.archlinux.org/index.php/Pacman_Tips
+ alias yaupg='yaourt -Syu' # Synchronize with repositories before upgrading packages that are out of date on the local system.
+ alias yain='yaourt -S' # Install specific package(s) from the repositories
+ alias yains='yaourt -U' # Install specific package not from the repositories but from a file
+ alias yare='yaourt -R' # Remove the specified package(s), retaining its configuration(s) and required dependencies
+ alias yarem='yaourt -Rns' # Remove the specified package(s), its configuration(s) and unneeded dependencies
+ alias yarep='yaourt -Si' # Display information about a given package in the repositories
+ alias yareps='yaourt -Ss' # Search for package(s) in the repositories
+ alias yaloc='yaourt -Qi' # Display information about a given package in the local database
+ alias yalocs='yaourt -Qs' # Search for package(s) in the local database
+ # Additional yaourt alias examples
+ if [[ -x `which abs` ]]; then
+ alias yaupd='yaourt -Sy && sudo abs' # Update and refresh the local package and ABS databases against repositories
+ else
+ alias yaupd='yaourt -Sy' # Update and refresh the local package and ABS databases against repositories
+ fi
+ alias yainsd='yaourt -S --asdeps' # Install given package(s) as dependencies of another package
+ alias yamir='yaourt -Syy' # Force refresh of all package lists after updating /etc/pacman.d/mirrorlist
+else
+ upgrade() {
+ sudo pacman -Syu
+ }
+fi
+
+# Pacman - https://wiki.archlinux.org/index.php/Pacman_Tips
+alias pacupg='sudo pacman -Syu' # Synchronize with repositories before upgrading packages that are out of date on the local system.
+alias pacin='sudo pacman -S' # Install specific package(s) from the repositories
+alias pacins='sudo pacman -U' # Install specific package not from the repositories but from a file
+alias pacre='sudo pacman -R' # Remove the specified package(s), retaining its configuration(s) and required dependencies
+alias pacrem='sudo pacman -Rns' # Remove the specified package(s), its configuration(s) and unneeded dependencies
+alias pacrep='pacman -Si' # Display information about a given package in the repositories
+alias pacreps='pacman -Ss' # Search for package(s) in the repositories
+alias pacloc='pacman -Qi' # Display information about a given package in the local database
+alias paclocs='pacman -Qs' # Search for package(s) in the local database
+# Additional pacman alias examples
+if [[ -x `which abs` ]]; then
+ alias pacupd='sudo pacman -Sy && sudo abs' # Update and refresh the local package and ABS databases against repositories
+else
+ alias pacupd='sudo pacman -Sy' # Update and refresh the local package and ABS databases against repositories
+fi
+alias pacinsd='sudo pacman -S --asdeps' # Install given package(s) as dependencies of another package
+alias pacmir='sudo pacman -Syy' # Force refresh of all package lists after updating /etc/pacman.d/mirrorlist
+
+# https://bbs.archlinux.org/viewtopic.php?id=93683
+paclist() {
+ sudo pacman -Qei $(pacman -Qu|cut -d" " -f 1)|awk ' BEGIN {FS=":"}/^Name/{printf("\033[1;36m%s\033[1;37m", $2)}/^Description/{print $2}'
+}
+
+alias paclsorphans='sudo pacman -Qdt'
+alias pacrmorphans='sudo pacman -Rs $(pacman -Qtdq)'
+
+pacdisowned() {
+ tmp=${TMPDIR-/tmp}/pacman-disowned-$UID-$$
+ db=$tmp/db
+ fs=$tmp/fs
+
+ mkdir "$tmp"
+ trap 'rm -rf "$tmp"' EXIT
+
+ pacman -Qlq | sort -u > "$db"
+
+ find /bin /etc /lib /sbin /usr \
+ ! -name lost+found \
+ \( -type d -printf '%p/\n' -o -print \) | sort > "$fs"
+
+ comm -23 "$fs" "$db"
+}
diff --git a/plugins/autojump/autojump.plugin.zsh b/plugins/autojump/autojump.plugin.zsh
new file mode 100644
index 000000000..da0a12765
--- /dev/null
+++ b/plugins/autojump/autojump.plugin.zsh
@@ -0,0 +1,3 @@
+if [ -f `brew --prefix`/etc/autojump ]; then
+ . `brew --prefix`/etc/autojump
+fi
diff --git a/plugins/brew/_brew b/plugins/brew/_brew
index cee1e25f0..1dcf0a4bf 100644
--- a/plugins/brew/_brew
+++ b/plugins/brew/_brew
@@ -25,10 +25,12 @@ _1st_arguments=(
'link:link a formula'
'list:list files in a formula or not-installed formulae'
'log:git commit log for a formula'
+ 'missing:check all installed formuale for missing dependencies.'
'outdated:list formulas for which a newer version is available'
'prune:remove dead links'
'remove:remove a formula'
'search:search for a formula (/regex/ or string)'
+ 'server:start a local web app that lets you browse formulae (requires Sinatra)'
'unlink:unlink a formula'
'update:freshen up links'
'upgrade:upgrade outdated formulae'
@@ -36,10 +38,14 @@ _1st_arguments=(
)
local expl
-local -a formula installed_formulae
+local -a formulae installed_formulae
_arguments \
- '(-v --verbose)'{-v,--verbose}'[verbose]' \
+ '(-v)-v[verbose]' \
+ '(--cellar)--cellar[brew cellar]' \
+ '(--config)--config[brew configuration]' \
+ '(--env)--env[brew environment]' \
+ '(--repository)--repository[brew repository]' \
'(--version)--version[version information]' \
'(--prefix)--prefix[where brew lives on this system]' \
'(--cache)--cache[brew cache]' \
@@ -51,20 +57,24 @@ if (( CURRENT == 1 )); then
fi
case "$words[1]" in
- list)
+ search|-S)
+ _arguments \
+ '(--macports)--macports[search the macports repository]' \
+ '(--fink)--fink[search the fink repository]' ;;
+ list|ls)
_arguments \
'(--unbrewed)--unbrewed[files in brew --prefix not controlled by brew]' \
+ '(--versions)--versions[list all installed versions of a formula]' \
'1: :->forms' && return 0
if [[ "$state" == forms ]]; then
_brew_installed_formulae
- _requested installed_formulae expl 'installed formulae' compadd -a installed_formulae
+ _wanted installed_formulae expl 'installed formulae' compadd -a installed_formulae
fi ;;
- install|home|log|info|uses|cat|deps)
+ install|home|homepage|log|info|abv|uses|cat|deps|edit|options)
_brew_all_formulae
_wanted formulae expl 'all formulae' compadd -a formulae ;;
- remove|edit|xo)
+ remove|rm|uninstall|unlink|cleanup|link|ln)
_brew_installed_formulae
_wanted installed_formulae expl 'installed formulae' compadd -a installed_formulae ;;
esac
-
diff --git a/plugins/brew/brew.plugin.zsh b/plugins/brew/brew.plugin.zsh
new file mode 100644
index 000000000..c2e95884e
--- /dev/null
+++ b/plugins/brew/brew.plugin.zsh
@@ -0,0 +1 @@
+alias brews='brew list -1'
diff --git a/plugins/bundler/bundler.plugin.zsh b/plugins/bundler/bundler.plugin.zsh
index fb40e2cec..a6c116407 100644
--- a/plugins/bundler/bundler.plugin.zsh
+++ b/plugins/bundler/bundler.plugin.zsh
@@ -1,3 +1,37 @@
alias be="bundle exec"
alias bi="bundle install"
+alias bl="bundle list"
alias bu="bundle update"
+alias bp="bundle package"
+
+# The following is based on https://github.com/gma/bundler-exec
+
+bundled_commands=(cap capify cucumber guard heroku rackup rails rake rspec ruby shotgun spec spork thin unicorn unicorn_rails)
+
+## Functions
+
+_bundler-installed() {
+ which bundle > /dev/null 2>&1
+}
+
+_within-bundled-project() {
+ local check_dir=$PWD
+ while [ "$(dirname $check_dir)" != "/" ]; do
+ [ -f "$check_dir/Gemfile" ] && return
+ check_dir="$(dirname $check_dir)"
+ done
+ false
+}
+
+_run-with-bundler() {
+ if _bundler-installed && _within-bundled-project; then
+ bundle exec $@
+ else
+ $@
+ fi
+}
+
+## Main program
+for cmd in $bundled_commands; do
+ alias $cmd="_run-with-bundler $cmd"
+done
diff --git a/plugins/cake/cake.plugin.zsh b/plugins/cake/cake.plugin.zsh
new file mode 100644
index 000000000..f968c71d5
--- /dev/null
+++ b/plugins/cake/cake.plugin.zsh
@@ -0,0 +1,32 @@
+# Set this to 1 if you want to cache the tasks
+cache_task_list=1
+
+# Cache filename
+cache_file='.cake_task_cache'
+
+_cake_does_target_list_need_generating () {
+
+ if [ $cache_task_list -eq 0 ]; then
+ return 1;
+ fi
+
+ if [ ! -f $cache_file ]; then return 0;
+ else
+ accurate=$(stat -f%m $cache_file)
+ changed=$(stat -f%m Cakefile)
+ return $(expr $accurate '>=' $changed)
+ fi
+}
+
+_cake () {
+ if [ -f Cakefile ]; then
+ if _cake_does_target_list_need_generating; then
+ cake | sed -e "s/cake \([^ ]*\) .*/\1/" | grep -v '^$' > $cache_file
+ compadd `cat $cache_file`
+ else
+ compadd `cake | sed -e "s/cake \([^ ]*\) .*/\1/" | grep -v '^$'`
+ fi
+ fi
+}
+
+compdef _cake cake
diff --git a/plugins/cap/cap.plugin.zsh b/plugins/cap/cap.plugin.zsh
index a0fa21d00..8336182d5 100644
--- a/plugins/cap/cap.plugin.zsh
+++ b/plugins/cap/cap.plugin.zsh
@@ -18,4 +18,4 @@ function _cap () {
fi
}
-compctl -K _cap cap \ No newline at end of file
+compctl -K _cap cap
diff --git a/plugins/cloudapp/cloudapp.plugin.zsh b/plugins/cloudapp/cloudapp.plugin.zsh
new file mode 100644
index 000000000..99252f690
--- /dev/null
+++ b/plugins/cloudapp/cloudapp.plugin.zsh
@@ -0,0 +1,2 @@
+#!/bin/zsh
+alias cloudapp=$ZSH/plugins/cloudapp/cloudapp.rb
diff --git a/plugins/cloudapp/cloudapp.rb b/plugins/cloudapp/cloudapp.rb
new file mode 100755
index 000000000..a11cfdb32
--- /dev/null
+++ b/plugins/cloudapp/cloudapp.rb
@@ -0,0 +1,60 @@
+#!/usr/bin/env ruby
+#
+# cloudapp
+# Zach Holman / @holman
+#
+# Uploads a file from the command line to CloudApp, drops it into your
+# clipboard (on a Mac, at least).
+#
+# Example:
+#
+# cloudapp drunk-blake.png
+#
+# This requires Aaron Russell's cloudapp_api gem:
+#
+# gem install cloudapp_api
+#
+# Requires you set your CloudApp credentials in ~/.cloudapp as a simple file of:
+#
+# email
+# password
+
+require 'rubygems'
+begin
+ require 'cloudapp_api'
+rescue LoadError
+ puts "You need to install cloudapp_api: gem install cloudapp_api"
+ exit!(1)
+end
+
+config_file = "#{ENV['HOME']}/.cloudapp"
+unless File.exist?(config_file)
+ puts "You need to type your email and password (one per line) into "+
+ "`~/.cloudapp`"
+ exit!(1)
+end
+
+email,password = File.read(config_file).split("\n")
+
+class HTTParty::Response
+ # Apparently HTTPOK.ok? IS NOT OKAY WTFFFFFFFFFFUUUUUUUUUUUUUU
+ # LETS MONKEY PATCH IT I FEEL OKAY ABOUT IT
+ def ok? ; true end
+end
+
+if ARGV[0].nil?
+ puts "You need to specify a file to upload."
+ exit!(1)
+end
+
+CloudApp.authenticate(email,password)
+url = CloudApp::Item.create(:upload, {:file => ARGV[0]}).url
+
+# Say it for good measure.
+puts "Uploaded to #{url}."
+
+# Get the embed link.
+url = "#{url}/#{ARGV[0].split('/').last}"
+
+# Copy it to your (Mac's) clipboard.
+`echo '#{url}' | tr -d "\n" | pbcopy`
diff --git a/plugins/compleat/compleat.plugin.zsh b/plugins/compleat/compleat.plugin.zsh
index 8d16a5687..38f1b396a 100644
--- a/plugins/compleat/compleat.plugin.zsh
+++ b/plugins/compleat/compleat.plugin.zsh
@@ -5,7 +5,6 @@
# VERSION: 1.0.0
# ------------------------------------------------------------------------------
-
if (( ${+commands[compleat]} )); then
local prefix="${commands[compleat]:h:h}"
local setup="${prefix}/share/compleat-1.0/compleat_setup"
@@ -19,4 +18,3 @@ if (( ${+commands[compleat]} )); then
source "$setup"
fi
fi
-
diff --git a/plugins/django/django.plugin.zsh b/plugins/django/django.plugin.zsh
new file mode 100644
index 000000000..1d72a2f2c
--- /dev/null
+++ b/plugins/django/django.plugin.zsh
@@ -0,0 +1,222 @@
+#compdef manage.py
+
+typeset -ga nul_args
+nul_args=(
+ '--settings=-[the Python path to a settings module.]:file:_files'
+ '--pythonpath=-[a directory to add to the Python path.]::directory:_directories'
+ '--traceback[print traceback on exception.]'
+ "--version[show program's version number and exit.]"
+ {-h,--help}'[show this help message and exit.]'
+)
+
+_managepy-adminindex(){
+ _arguments -s : \
+ $nul_args \
+ '*::directory:_directories' && ret=0
+}
+
+_managepy-createcachetable(){
+ _arguments -s : \
+ $nul_args && ret=0
+}
+
+_managepy-dbshell(){
+ _arguments -s : \
+ $nul_args && ret=0
+}
+
+_managepy-diffsettings(){
+ _arguments -s : \
+ $nul_args && ret=0
+}
+
+_managepy-dumpdata(){
+ _arguments -s : \
+ '--format=-[specifies the output serialization format for fixtures.]:format:(json yaml xml)' \
+ '--indent=-[specifies the indent level to use when pretty-printing output.]:' \
+ $nul_args \
+ '*::appname:_applist' && ret=0
+}
+
+_managepy-flush(){
+ _arguments -s : \
+ '--verbosity=-[verbosity level; 0=minimal output, 1=normal output, 2=all output.]:Verbosity:((0\:minimal 1\:normal 2\:all))' \
+ '--noinput[tells Django to NOT prompt the user for input of any kind.]' \
+ $nul_args && ret=0
+}
+
+_managepy-help(){
+ _arguments -s : \
+ '*:command:_managepy_cmds' \
+ $nul_args && ret=0
+}
+
+_managepy_cmds(){
+ local line
+ local -a cmd
+ _call_program help-command ./manage.py help \
+ |& sed -n '/^ /s/[(), ]/ /gp' \
+ | while read -A line; do cmd=($line $cmd) done
+ _describe -t managepy-command 'manage.py command' cmd
+}
+
+_managepy-inspectdb(){
+ _arguments -s : \
+ $nul_args && ret=0
+}
+
+_managepy-loaddata(){
+ _arguments -s : \
+ '--verbosity=-[verbosity level; 0=minimal output, 1=normal output, 2=all output.]:Verbosity:((0\:minimal 1\:normal 2\:all))' \
+ '*::file:_files' \
+ $nul_args && ret=0
+}
+
+_managepy-reset(){
+ _arguments -s : \
+ '--noinput[tells Django to NOT prompt the user for input of any kind.]' \
+ '*::appname:_applist' \
+ $nul_args && ret=0
+}
+
+_managepy-runfcgi(){
+ local state
+
+ local fcgi_opts
+ fcgi_opts=(
+ 'protocol[fcgi, scgi, ajp, ... (default fcgi)]:protocol:(fcgi scgi ajp)'
+ 'host[hostname to listen on..]:'
+ 'port[port to listen on.]:'
+ 'socket[UNIX socket to listen on.]::file:_files'
+ 'method[prefork or threaded (default prefork)]:method:(prefork threaded)'
+ 'maxrequests[number of requests a child handles before it is killed and a new child is forked (0 = no limit).]:'
+ 'maxspare[max number of spare processes / threads.]:'
+ 'minspare[min number of spare processes / threads.]:'
+ 'maxchildren[hard limit number of processes / threads.]:'
+ 'daemonize[whether to detach from terminal.]:boolean:(False True)'
+ 'pidfile[write the spawned process-id to this file.]:file:_files'
+ 'workdir[change to this directory when daemonizing.]:directory:_files'
+ 'outlog[write stdout to this file.]:file:_files'
+ 'errlog[write stderr to this file.]:file:_files'
+ )
+
+ _arguments -s : \
+ $nul_args \
+ '*: :_values "FCGI Setting" $fcgi_opts' && ret=0
+}
+
+_managepy-runserver(){
+ _arguments -s : \
+ '--noreload[tells Django to NOT use the auto-reloader.]' \
+ '--adminmedia[specifies the directory from which to serve admin media.]:directory:_files' \
+ $nul_args && ret=0
+}
+
+_managepy-shell(){
+ _arguments -s : \
+ '--plain[tells Django to use plain Python, not IPython.]' \
+ $nul_args && ret=0
+}
+
+_managepy-sql(){}
+_managepy-sqlall(){}
+_managepy-sqlclear(){}
+_managepy-sqlcustom(){}
+_managepy-sqlflush(){}
+_managepy-sqlindexes(){}
+_managepy-sqlinitialdata(){}
+_managepy-sqlreset(){}
+_managepy-sqlsequencereset(){}
+_managepy-startapp(){}
+
+_managepy-syncdb() {
+ _arguments -s : \
+ '--verbosity=-[verbosity level; 0=minimal output, 1=normal output, 2=all output.]:Verbosity:((0\:minimal 1\:normal 2\:all))' \
+ '--noinput[tells Django to NOT prompt the user for input of any kind.]' \
+ $nul_args && ret=0
+}
+
+_managepy-test() {
+ _arguments -s : \
+ '--verbosity=-[verbosity level; 0=minimal output, 1=normal output, 2=all output.]:Verbosity:((0\:minimal 1\:normal 2\:all))' \
+ '--noinput[tells Django to NOT prompt the user for input of any kind.]' \
+ '*::appname:_applist' \
+ $nul_args && ret=0
+}
+
+_managepy-testserver() {
+ _arguments -s : \
+ '--verbosity=-[verbosity level; 0=minimal output, 1=normal output, 2=all output.]:Verbosity:((0\:minimal 1\:normal 2\:all))' \
+ '--addrport=-[port number or ipaddr:port to run the server on.]' \
+ '*::fixture:_files' \
+ $nul_args && ret=0
+}
+
+_managepy-validate() {
+ _arguments -s : \
+ $nul_args && ret=0
+}
+
+_managepy-commands() {
+ local -a commands
+
+ commands=(
+ 'adminindex:prints the admin-index template snippet for the given app name(s).'
+ 'createcachetable:creates the table needed to use the SQL cache backend.'
+ 'dbshell:runs the command-line client for the current DATABASE_ENGINE.'
+ "diffsettings:displays differences between the current settings.py and Django's default settings."
+ 'dumpdata:Output the contents of the database as a fixture of the given format.'
+ 'flush:Executes ``sqlflush`` on the current database.'
+ 'help:manage.py help.'
+ 'inspectdb:Introspects the database tables in the given database and outputs a Django model module.'
+ 'loaddata:Installs the named fixture(s) in the database.'
+ 'reset:Executes ``sqlreset`` for the given app(s) in the current database.'
+ 'runfcgi:Run this project as a fastcgi (or some other protocol supported by flup) application,'
+ 'runserver:Starts a lightweight Web server for development.'
+ 'shell:Runs a Python interactive interpreter.'
+ 'sql:Prints the CREATE TABLE SQL statements for the given app name(s).'
+ 'sqlall:Prints the CREATE TABLE, custom SQL and CREATE INDEX SQL statements for the given model module name(s).'
+ 'sqlclear:Prints the DROP TABLE SQL statements for the given app name(s).'
+ 'sqlcustom:Prints the custom table modifying SQL statements for the given app name(s).'
+ 'sqlflush:Returns a list of the SQL statements required to return all tables in the database to the state they were in just after they were installed.'
+ 'sqlindexes:Prints the CREATE INDEX SQL statements for the given model module name(s).'
+ "sqlinitialdata:RENAMED: see 'sqlcustom'"
+ 'sqlreset:Prints the DROP TABLE SQL, then the CREATE TABLE SQL, for the given app name(s).'
+ 'sqlsequencereset:Prints the SQL statements for resetting sequences for the given app name(s).'
+ "startapp:Creates a Django app directory structure for the given app name in this project's directory."
+ "syncdb:Create the database tables for all apps in INSTALLED_APPS whose tables haven't already been created."
+ 'test:Runs the test suite for the specified applications, or the entire site if no apps are specified.'
+ 'testserver:Runs a development server with data from the given fixture(s).'
+ 'validate:Validates all installed models.'
+ )
+
+ _describe -t commands 'manage.py command' commands && ret=0
+}
+
+_applist() {
+ local line
+ local -a apps
+ _call_program help-command "python -c \"import os.path as op, re, django.conf, sys;\\
+ bn=op.basename(op.abspath(op.curdir));[sys\\
+ .stdout.write(str(re.sub(r'^%s\.(.*?)$' %
+ bn, r'\1', i)) + '\n') for i in django.conf.settings.\\
+ INSTALLED_APPS if re.match(r'^%s' % bn, i)]\"" \
+ | while read -A line; do apps=($line $apps) done
+ _values 'Application' $apps && ret=0
+}
+
+_managepy() {
+ local curcontext=$curcontext ret=1
+
+ if ((CURRENT == 2)); then
+ _managepy-commands
+ else
+ shift words
+ (( CURRENT -- ))
+ curcontext="${curcontext%:*:*}:managepy-$words[1]:"
+ _call_function ret _managepy-$words[1]
+ fi
+}
+
+compdef _managepy manage.py
+compdef _managepy django
diff --git a/plugins/extract/_extract b/plugins/extract/_extract
new file mode 100644
index 000000000..dca890954
--- /dev/null
+++ b/plugins/extract/_extract
@@ -0,0 +1,8 @@
+#compdef extract
+#autoload
+
+_arguments \
+ '(-r --remove)'{-r,--remove}'[Remove archive.]' \
+ "*::archive file:_files -g '(#i)*.(tar|tgz|tbz|tbz2|txz|tlz|gz|bz2|xz|lzma|Z|zip|rar|7z|deb)(-.)'" && return 0
+
+
diff --git a/plugins/extract/extract.plugin.zsh b/plugins/extract/extract.plugin.zsh
new file mode 100644
index 000000000..8cc17f7d4
--- /dev/null
+++ b/plugins/extract/extract.plugin.zsh
@@ -0,0 +1,85 @@
+# ------------------------------------------------------------------------------
+# FILE: extract.plugin.zsh
+# DESCRIPTION: oh-my-zsh plugin file.
+# AUTHOR: Sorin Ionescu (sorin.ionescu@gmail.com)
+# VERSION: 1.0.1
+# ------------------------------------------------------------------------------
+
+
+function extract() {
+ local remove_archive
+ local success
+ local file_name
+ local extract_dir
+
+ if (( $# == 0 )); then
+ echo "Usage: extract [-option] [file ...]"
+ echo
+ echo Options:
+ echo " -r, --remove Remove archive."
+ echo
+ echo "Report bugs to <sorin.ionescu@gmail.com>."
+ fi
+
+ remove_archive=1
+ if [[ "$1" == "-r" ]] || [[ "$1" == "--remove" ]]; then
+ remove_archive=0
+ shift
+ fi
+
+ while (( $# > 0 )); do
+ if [[ ! -f "$1" ]]; then
+ echo "extract: '$1' is not a valid file" 1>&2
+ shift
+ continue
+ fi
+
+ success=0
+ file_name="$( basename "$1" )"
+ extract_dir="$( echo "$file_name" | sed "s/\.${1##*.}//g" )"
+ case "$1" in
+ (*.tar.gz|*.tgz) tar xvzf "$1" ;;
+ (*.tar.bz2|*.tbz|*.tbz2) tar xvjf "$1" ;;
+ (*.tar.xz|*.txz) tar --xz --help &> /dev/null \
+ && tar --xz -xvf "$1" \
+ || xzcat "$1" | tar xvf - ;;
+ (*.tar.zma|*.tlz) tar --lzma --help &> /dev/null \
+ && tar --lzma -xvf "$1" \
+ || lzcat "$1" | tar xvf - ;;
+ (*.tar) tar xvf "$1" ;;
+ (*.gz) gunzip "$1" ;;
+ (*.bz2) bunzip2 "$1" ;;
+ (*.xz) unxz "$1" ;;
+ (*.lzma) unlzma "$1" ;;
+ (*.Z) uncompress "$1" ;;
+ (*.zip) unzip "$1" -d $extract_dir ;;
+ (*.rar) unrar e -ad "$1" ;;
+ (*.7z) 7za x "$1" ;;
+ (*.deb)
+ mkdir -p "$extract_dir/control"
+ mkdir -p "$extract_dir/data"
+ cd "$extract_dir"; ar vx "../${1}" > /dev/null
+ cd control; tar xzvf ../control.tar.gz
+ cd ../data; tar xzvf ../data.tar.gz
+ cd ..; rm *.tar.gz debian-binary
+ cd ..
+ ;;
+ (*)
+ echo "extract: '$1' cannot be extracted" 1>&2
+ success=1
+ ;;
+ esac
+
+ (( success = $success > 0 ? $success : $? ))
+ (( $success == 0 )) && (( $remove_archive == 0 )) && rm "$1"
+ shift
+ done
+}
+
+alias x=extract
+
+# add extract completion function to path
+fpath=($ZSH/plugins/extract $fpath)
+autoload -U compinit
+compinit -i
+
diff --git a/plugins/gas/_gas b/plugins/gas/_gas
new file mode 100644
index 000000000..befdc9459
--- /dev/null
+++ b/plugins/gas/_gas
@@ -0,0 +1,34 @@
+#compdef gas
+
+local curcontext="$curcontext" state line cmds ret=1
+
+_arguments -C \
+ '(- 1 *)'{-v,--version}'[display version information]' \
+ '(-h|--help)'{-h,--help}'[show help information]' \
+ '1: :->cmds' \
+ '*: :->args' && ret=0
+
+case $state in
+ cmds)
+ cmds=(
+ "version:Prints Gas's version"
+ "use:Uses author"
+ "show:Shows your current user"
+ "list:Lists your authors"
+ "import:Imports current user to gasconfig"
+ "help:Describe available tasks or one specific task"
+ "delete:Deletes author"
+ "add:Adds author to gasconfig"
+ )
+ _describe -t commands 'gas command' cmds && ret=0
+ ;;
+ args)
+ case $line[1] in
+ (use|delete)
+ _values -S , 'authors' $(cat ~/.gas | sed -n -e 's/^\[\(.*\)\]/\1/p') && ret=0
+ ;;
+ esac
+ ;;
+esac
+
+return ret
diff --git a/plugins/git/git.plugin.zsh b/plugins/git/git.plugin.zsh
index bc340e86b..4fcf9425d 100644
--- a/plugins/git/git.plugin.zsh
+++ b/plugins/git/git.plugin.zsh
@@ -27,11 +27,19 @@ alias gcp='git cherry-pick'
compdef _git gcp=git-cherry-pick
alias glg='git log --stat --max-count=5'
compdef _git glg=git-log
+alias glgg='git log --graph --max-count=5'
+compdef _git glgg=git-log
+alias gss='git status -s'
+compdef _git gss=git-status
+alias ga='git add'
+compdef _git ga=git-add
# Git and svn mix
alias git-svn-dcommit-push='git svn dcommit && git push github master:svntrunk'
compdef git-svn-dcommit-push=git
+alias gsr='git svn rebase'
+alias gsd='git svn dcommit'
#
# Will return the current branch name
# Usage example: git pull origin $(current_branch)
diff --git a/plugins/github/github.plugin.zsh b/plugins/github/github.plugin.zsh
index df7053ba7..1eb338113 100644
--- a/plugins/github/github.plugin.zsh
+++ b/plugins/github/github.plugin.zsh
@@ -4,4 +4,3 @@ if [ "$commands[(I)hub]" ]; then
# eval `hub alias -s zsh`
function git(){hub "$@"}
fi
-
diff --git a/plugins/gpg-agent/gpg-agent.plugin.zsh b/plugins/gpg-agent/gpg-agent.plugin.zsh
new file mode 100644
index 000000000..8cc71fd57
--- /dev/null
+++ b/plugins/gpg-agent/gpg-agent.plugin.zsh
@@ -0,0 +1,26 @@
+# Based on ssh-agent code
+
+local GPG_ENV=$HOME/.gnupg/gpg-agent.env
+
+function start_agent {
+ /usr/bin/env gpg-agent --daemon --enable-ssh-support --write-env-file ${GPG_ENV} > /dev/null
+ chmod 600 ${GPG_ENV}
+ . ${GPG_ENV} > /dev/null
+}
+
+# Source GPG agent settings, if applicable
+if [ -f "${GPG_ENV}" ]; then
+ . ${GPG_ENV} > /dev/null
+ ps -ef | grep ${SSH_AGENT_PID} | grep gpg-agent > /dev/null || {
+ start_agent;
+ }
+else
+ start_agent;
+fi
+
+export GPG_AGENT_INFO
+export SSH_AUTH_SOCK
+export SSH_AGENT_PID
+
+GPG_TTY=$(tty)
+export GPG_TTY
diff --git a/plugins/heroku/_heroku b/plugins/heroku/_heroku
new file mode 100644
index 000000000..dc899e2b2
--- /dev/null
+++ b/plugins/heroku/_heroku
@@ -0,0 +1,158 @@
+#compdef heroku
+
+# Heroku Autocomplete plugin for Oh-My-Zsh
+# Requires: The Heroku client gem (https://github.com/heroku/heroku)
+# Author: Ali B. (http://awhitebox.com)
+
+local -a _1st_arguments
+_1st_arguments=(
+ "account\:confirm_billing":"Confirm that your account can be billed at the end of the month"
+ "addons":"list installed addons"
+ "addons\:list":"list all available addons"
+ "addons\:add":"install an addon"
+ "addons\:upgrade":"upgrade an existing addon"
+ "addons\:downgrade":"downgrade an existing addon"
+ "addons\:remove":"uninstall an addon"
+ "addons\:open":"open an addon's dashboard in your browser"
+ "apps":"list your apps"
+ "apps\:info":"show detailed app information"
+ "apps\:create":"create a new app"
+ "apps\:rename":"rename the app"
+ "apps\:open":"open the app in a web browser"
+ "apps\:destroy":"permanently destroy an app"
+ "auth\:login":"log in with your heroku credentials"
+ "auth\:logout":"clear local authentication credentials"
+ "config":"display the config vars for an app"
+ "config\:add":"add one or more config vars"
+ "config\:remove":"remove a config var"
+ "db\:push":"push local data up to your app"
+ "db\:pull":"pull heroku data down into your local database"
+ "domains":"list custom domains for an app"
+ "domains\:add":"add a custom domain to an app"
+ "domains\:remove":"remove a custom domain from an app"
+ "domains\:clear":"remove all custom domains from an app"
+ "help":"list available commands or display help for a specific command"
+ "keys":"display keys for the current user"
+ "keys\:add":"add a key for the current user"
+ "keys\:remove":"remove a key from the current user"
+ "keys\:clear":"remove all authentication keys from the current user"
+ "logs":"display recent log output"
+ "logs\:cron":"DEPRECATED: display cron logs from legacy logging"
+ "logs\:drains":"manage syslog drains"
+ "maintenance\:on":"put the app into maintenance mode"
+ "maintenance\:off":"take the app out of maintenance mode"
+ "pg\:info":"display database information"
+ "pg\:ingress":"allow direct connections to the database from this IP for one minute"
+ "pg\:promote":"sets DATABASE as your DATABASE_URL"
+ "pg\:psql":"open a psql shell to the database"
+ "pg\:reset":"delete all data in DATABASE"
+ "pg\:unfollow":"stop a replica from following and make it a read/write database"
+ "pg\:wait":"monitor database creation, exit when complete"
+ "pgbackups":"list captured backups"
+ "pgbackups\:url":"get a temporary URL for a backup"
+ "pgbackups\:capture":"capture a backup from a database id"
+ "pgbackups\:restore":"restore a backup to a database"
+ "pgbackups\:destroy":"destroys a backup"
+ "plugins":"list installed plugins"
+ "plugins\:install":"install a plugin"
+ "plugins\:uninstall":"uninstall a plugin"
+ "ps\:dynos":"scale to QTY web processes"
+ "ps\:workers":"scale to QTY background processes"
+ "ps":"list processes for an app"
+ "ps\:restart":"restart an app process"
+ "ps\:scale":"scale processes by the given amount"
+ "releases":"list releases"
+ "releases\:info":"view detailed information for a release"
+ "rollback":"roll back to an older release"
+ "run":"run an attached process"
+ "run\:rake":"remotely execute a rake command"
+ "run\:console":"open a remote console session"
+ "sharing":"list collaborators on an app"
+ "sharing\:add":"add a collaborator to an app"
+ "sharing\:remove":"remove a collaborator from an app"
+ "sharing\:transfer":"transfer an app to a new owner"
+ "ssl":"list certificates for an app"
+ "ssl\:add":"add an ssl certificate to an app"
+ "ssl\:remove":"remove an ssl certificate from an app"
+ "ssl\:clear":"remove all ssl certificates from an app"
+ "stack":"show the list of available stacks"
+ "stack\:migrate":"prepare migration of this app to a new stack"
+ "version":"show heroku client version"
+)
+
+_arguments '*:: :->command'
+
+if (( CURRENT == 1 )); then
+ _describe -t commands "heroku command" _1st_arguments
+ return
+fi
+
+local -a _command_args
+case "$words[1]" in
+ apps:info)
+ _command_args=(
+ '(-r|--raw)'{-r,--raw}'[output info as raw key/value pairs]' \
+ )
+ ;;
+ apps:create)
+ _command_args=(
+ '(-a|--addons)'{-a,--addons}'[a list of addons to install]' \
+ '(-r|--remote)'{-r,--remote}'[the git remote to create, default "heroku"]' \
+ '(-s|--stack)'{-s,--stack}'[the stack on which to create the app]' \
+ )
+ ;;
+ config)
+ _command_args=(
+ '(-s|--shell)'{-s,--shell}'[output config vars in shell format]' \
+ )
+ ;;
+ db:push)
+ _command_args=(
+ '(-c|--chunksize)'{-c,--chunksize}'[specify the number of rows to send in each batch]' \
+ '(-d|--debug)'{-d,--debug}'[enable debugging output]' \
+ '(-e|--exclude)'{-e,--exclude}'[exclude the specified tables from the push]' \
+ '(-f|--filter)'{-f,--filter}'[only push certain tables]' \
+ '(-r|--resume)'{-r,--resume}'[resume transfer described by a .dat file]' \
+ '(-t|--tables)'{-t,--tables}'[only push the specified tables]' \
+ )
+ ;;
+ db:pull)
+ _command_args=(
+ '(-c|--chunksize)'{-c,--chunksize}'[specify the number of rows to send in each batch]' \
+ '(-d|--debug)'{-d,--debug}'[enable debugging output]' \
+ '(-e|--exclude)'{-e,--exclude}'[exclude the specified tables from the pull]' \
+ '(-f|--filter)'{-f,--filter}'[only pull certain tables]' \
+ '(-r|--resume)'{-r,--resume}'[resume transfer described by a .dat file]' \
+ '(-t|--tables)'{-t,--tables}'[only pull the specified tables]' \
+ )
+ ;;
+ keys)
+ _command_args=(
+ '(-l|--long)'{-l,--long}'[display extended information for each key]' \
+ )
+ ;;
+ logs)
+ _command_args=(
+ '(-n|--num)'{-n,--num}'[the number of lines to display]' \
+ '(-p|--ps)'{-p,--ps}'[only display logs from the given process]' \
+ '(-s|--source)'{-s,--source}'[only display logs from the given source]' \
+ '(-t|--tail)'{-t,--tail}'[continually stream logs]' \
+ )
+ ;;
+ pgbackups:capture)
+ _command_args=(
+ '(-e|--expire)'{-e,--expire}'[if no slots are available to capture, delete the oldest backup to make room]' \
+ )
+ ;;
+ stack)
+ _command_args=(
+ '(-a|--all)'{-a,--all}'[include deprecated stacks]' \
+ )
+ ;;
+ esac
+
+_arguments \
+ $_command_args \
+ '(--app)--app[the app name]' \
+ && return 0
+
diff --git a/plugins/history-substring-search/README b/plugins/history-substring-search/README
new file mode 100644
index 000000000..be11adf76
--- /dev/null
+++ b/plugins/history-substring-search/README
@@ -0,0 +1,7 @@
+To activate this script, load it into an interactive ZSH session:
+
+ % source history-substring-search.zsh
+
+See the "history-substring-search.zsh" file for more information:
+
+ % sed -n '2,/^$/s/^#//p' history-substring-search.zsh | more
diff --git a/plugins/history-substring-search/history-substring-search.plugin.zsh b/plugins/history-substring-search/history-substring-search.plugin.zsh
new file mode 100644
index 000000000..99a5922c5
--- /dev/null
+++ b/plugins/history-substring-search/history-substring-search.plugin.zsh
@@ -0,0 +1,12 @@
+# This file integrates the history-substring-search script into oh-my-zsh.
+
+source "$ZSH/plugins/history-substring-search/history-substring-search.zsh"
+
+if test "$CASE_SENSITIVE" = true; then
+ unset HISTORY_SUBSTRING_SEARCH_GLOBBING_FLAGS
+fi
+
+if test "$DISABLE_COLOR" = true; then
+ unset HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_FOUND
+ unset HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_NOT_FOUND
+fi
diff --git a/plugins/history-substring-search/history-substring-search.zsh b/plugins/history-substring-search/history-substring-search.zsh
new file mode 100644
index 000000000..53f707c79
--- /dev/null
+++ b/plugins/history-substring-search/history-substring-search.zsh
@@ -0,0 +1,642 @@
+#!/usr/bin/env zsh
+#
+# This is a clean-room implementation of the Fish[1] shell's history search
+# feature, where you can type in any part of any previously entered command
+# and press the UP and DOWN arrow keys to cycle through the matching commands.
+#
+#-----------------------------------------------------------------------------
+# Usage
+#-----------------------------------------------------------------------------
+#
+# 1. Load this script into your interactive ZSH session:
+#
+# % source history-substring-search.zsh
+#
+# If you want to use the zsh-syntax-highlighting[6] script along with this
+# script, then make sure that you load it *before* you load this script:
+#
+# % source zsh-syntax-highlighting.zsh
+# % source history-substring-search.zsh
+#
+# 2. Type any part of any previous command and then:
+#
+# * Press the UP arrow key to select the nearest command that (1) contains
+# your query and (2) is older than the current command in the command
+# history.
+#
+# * Press the DOWN arrow key to select the nearest command that (1)
+# contains your query and (2) is newer than the current command in the
+# command history.
+#
+# * Press ^U (the Control and U keys simultaneously) to abort the search.
+#
+# 3. If a matching command spans more than one line of text, press the LEFT
+# arrow key to move the cursor away from the end of the command, and then:
+#
+# * Press the UP arrow key to move the cursor to the line above. When the
+# cursor reaches the first line of the command, pressing the UP arrow
+# key again will cause this script to perform another search.
+#
+# * Press the DOWN arrow key to move the cursor to the line below. When
+# the cursor reaches the last line of the command, pressing the DOWN
+# arrow key again will cause this script to perform another search.
+#
+#-----------------------------------------------------------------------------
+# Configuration
+#-----------------------------------------------------------------------------
+#
+# This script defines the following global variables. You may override their
+# default values only after having loaded this script into your ZSH session.
+#
+# * HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_FOUND is a global variable that defines
+# how the query should be highlighted inside a matching command. Its default
+# value causes this script to highlight using bold, white text on a magenta
+# background. See the "Character Highlighting" section in the zshzle(1) man
+# page to learn about the kinds of values you may assign to this variable.
+#
+# * HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_NOT_FOUND is a global variable that
+# defines how the query should be highlighted when no commands in the
+# history match it. Its default value causes this script to highlight using
+# bold, white text on a red background. See the "Character Highlighting"
+# section in the zshzle(1) man page to learn about the kinds of values you
+# may assign to this variable.
+#
+# * HISTORY_SUBSTRING_SEARCH_GLOBBING_FLAGS is a global variable that defines
+# how the command history will be searched for your query. Its default value
+# causes this script to perform a case-insensitive search. See the "Globbing
+# Flags" section in the zshexpn(1) man page to learn about the kinds of
+# values you may assign to this variable.
+#
+#-----------------------------------------------------------------------------
+# History
+#-----------------------------------------------------------------------------
+#
+# This script was originally written by Peter Stephenson[2], who published it
+# to the ZSH users mailing list (thereby making it public domain) in September
+# 2009. It was later revised by Guido van Steen and released under the BSD
+# license (see below) as part of the fizsh[3] project in January 2011.
+#
+# It was later extracted from fizsh[3] release 1.0.1, refactored heavily, and
+# repackaged as both an oh-my-zsh plugin[4] and as an independently loadable
+# ZSH script[5] by Suraj N. Kurapati in 2011.
+#
+# It was further developed[4] by Guido van Steen, Suraj N. Kurapati, Sorin
+# Ionescu, and Vincent Guerci in 2011.
+#
+# [1]: http://fishshell.com
+# [2]: http://www.zsh.org/mla/users/2009/msg00818.html
+# [3]: http://sourceforge.net/projects/fizsh/
+# [4]: https://github.com/robbyrussell/oh-my-zsh/pull/215
+# [5]: https://github.com/sunaku/zsh-history-substring-search
+# [6]: https://github.com/nicoulaj/zsh-syntax-highlighting
+#
+##############################################################################
+#
+# Copyright (c) 2009 Peter Stephenson
+# Copyright (c) 2011 Guido van Steen
+# Copyright (c) 2011 Suraj N. Kurapati
+# Copyright (c) 2011 Sorin Ionescu
+# Copyright (c) 2011 Vincent Guerci
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# * Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# * Redistributions in binary form must reproduce the above
+# copyright notice, this list of conditions and the following
+# disclaimer in the documentation and/or other materials provided
+# with the distribution.
+#
+# * Neither the name of the FIZSH nor the names of its contributors
+# may be used to endorse or promote products derived from this
+# software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+#
+##############################################################################
+
+#-----------------------------------------------------------------------------
+# configuration variables
+#-----------------------------------------------------------------------------
+
+HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_FOUND='bg=magenta,fg=white,bold'
+HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_NOT_FOUND='bg=red,fg=white,bold'
+HISTORY_SUBSTRING_SEARCH_GLOBBING_FLAGS='i'
+
+#-----------------------------------------------------------------------------
+# the main ZLE widgets
+#-----------------------------------------------------------------------------
+
+function history-substring-search-up() {
+ _history-substring-search-begin
+
+ _history-substring-search-up-history ||
+ _history-substring-search-up-buffer ||
+ _history-substring-search-up-search
+
+ _history-substring-search-end
+}
+
+function history-substring-search-down() {
+ _history-substring-search-begin
+
+ _history-substring-search-down-history ||
+ _history-substring-search-down-buffer ||
+ _history-substring-search-down-search
+
+ _history-substring-search-end
+}
+
+zle -N history-substring-search-up
+zle -N history-substring-search-down
+
+bindkey '\e[A' history-substring-search-up
+bindkey '\e[B' history-substring-search-down
+
+#-----------------------------------------------------------------------------
+# implementation details
+#-----------------------------------------------------------------------------
+
+setopt extendedglob
+zmodload -F zsh/parameter
+
+#
+# We have to "override" some keys and widgets if the
+# zsh-syntax-highlighting plugin has not been loaded:
+#
+# https://github.com/nicoulaj/zsh-syntax-highlighting
+#
+if [[ $+functions[_zsh_highlight] -eq 0 ]]; then
+ #
+ # Dummy implementation of _zsh_highlight()
+ # that simply removes existing highlights
+ #
+ function _zsh_highlight() {
+ region_highlight=()
+ }
+
+ #
+ # Remove existing highlights when the user
+ # inserts printable characters into $BUFFER
+ #
+ function ordinary-key-press() {
+ if [[ $KEYS == [[:print:]] ]]; then
+ region_highlight=()
+ fi
+ zle .self-insert
+ }
+ zle -N self-insert ordinary-key-press
+
+ #
+ # Override ZLE widgets to invoke _zsh_highlight()
+ #
+ # https://github.com/nicoulaj/zsh-syntax-highlighting/blob/
+ # bb7fcb79fad797a40077bebaf6f4e4a93c9d8163/zsh-syntax-highlighting.zsh#L121
+ #
+ #--------------8<-------------------8<-------------------8<-----------------
+ #
+ # Copyright (c) 2010-2011 zsh-syntax-highlighting contributors
+ # All rights reserved.
+ #
+ # Redistribution and use in source and binary forms, with or without
+ # modification, are permitted provided that the following conditions are
+ # met:
+ #
+ # * Redistributions of source code must retain the above copyright
+ # notice, this list of conditions and the following disclaimer.
+ #
+ # * Redistributions in binary form must reproduce the above copyright
+ # notice, this list of conditions and the following disclaimer in the
+ # documentation and/or other materials provided with the distribution.
+ #
+ # * Neither the name of the zsh-syntax-highlighting contributors nor the
+ # names of its contributors may be used to endorse or promote products
+ # derived from this software without specific prior written permission.
+ #
+ # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
+ # IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
+ # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ # PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
+ # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ # EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ # PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+ # PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
+ # LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
+ # NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ # SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+ # Load ZSH module zsh/zleparameter, needed to override user defined widgets.
+ zmodload zsh/zleparameter 2>/dev/null || {
+ echo 'zsh-syntax-highlighting: failed loading zsh/zleparameter, exiting.' >&2
+ return -1
+ }
+
+ # Override ZLE widgets to make them invoke _zsh_highlight.
+ for event in ${${(f)"$(zle -la)"}:#(_*|orig-*|.run-help|.which-command)}; do
+ if [[ "$widgets[$event]" == completion:* ]]; then
+ eval "zle -C orig-$event ${${${widgets[$event]}#*:}/:/ } ; $event() { builtin zle orig-$event && _zsh_highlight } ; zle -N $event"
+ else
+ case $event in
+ accept-and-menu-complete)
+ eval "$event() { builtin zle .$event && _zsh_highlight } ; zle -N $event"
+ ;;
+
+ # The following widgets should NOT remove any previously
+ # applied highlighting. Therefore we do not remap them.
+ .forward-char|.backward-char|.up-line-or-history|.down-line-or-history)
+ ;;
+
+ .*)
+ clean_event=$event[2,${#event}] # Remove the leading dot in the event name
+ case ${widgets[$clean_event]-} in
+ (completion|user):*)
+ ;;
+ *)
+ eval "$clean_event() { builtin zle $event && _zsh_highlight } ; zle -N $clean_event"
+ ;;
+ esac
+ ;;
+ *)
+ ;;
+ esac
+ fi
+ done
+ unset event clean_event
+ #-------------->8------------------->8------------------->8-----------------
+fi
+
+function _history-substring-search-begin() {
+ _history_substring_search_move_cursor_eol=false
+ _history_substring_search_query_highlight=
+
+ #
+ # Continue using the previous $_history_substring_search_result by default,
+ # unless the current query was cleared or a new/different query was entered.
+ #
+ if [[ -z $BUFFER || $BUFFER != $_history_substring_search_result ]]; then
+ #
+ # For the purpose of highlighting we will also keep
+ # a version without doubly-escaped meta characters.
+ #
+ _history_substring_search_query=$BUFFER
+
+ #
+ # $BUFFER contains the text that is in the command-line currently.
+ # we put an extra "\\" before meta characters such as "\(" and "\)",
+ # so that they become "\\\(" and "\\\)".
+ #
+ _history_substring_search_query_escaped=${BUFFER//(#m)[\][()|\\*?#<>~^]/\\$MATCH}
+
+ #
+ # Find all occurrences of the search query in the history file.
+ #
+ # (k) turns it an array of line numbers.
+ #
+ # (on) seems to remove duplicates, which are default
+ # options. They can be turned off by (ON).
+ #
+ _history_substring_search_matches=(${(kon)history[(R)(#$HISTORY_SUBSTRING_SEARCH_GLOBBING_FLAGS)*${_history_substring_search_query_escaped}*]})
+
+ #
+ # Define the range of values that $_history_substring_search_match_index
+ # can take: [0, $_history_substring_search_matches_count_plus].
+ #
+ _history_substring_search_matches_count=$#_history_substring_search_matches
+ _history_substring_search_matches_count_plus=$(( _history_substring_search_matches_count + 1 ))
+ _history_substring_search_matches_count_sans=$(( _history_substring_search_matches_count - 1 ))
+
+ #
+ # If $_history_substring_search_match_index is equal to
+ # $_history_substring_search_matches_count_plus, this indicates that we
+ # are beyond the beginning of $_history_substring_search_matches.
+ #
+ # If $_history_substring_search_match_index is equal to 0, this indicates
+ # that we are beyond the end of $_history_substring_search_matches.
+ #
+ # If we have initially pressed "up" we have to initialize
+ # $_history_substring_search_match_index to
+ # $_history_substring_search_matches_count_plus so that it will be
+ # decreased to $_history_substring_search_matches_count.
+ #
+ # If we have initially pressed "down" we have to initialize
+ # $_history_substring_search_match_index to
+ # $_history_substring_search_matches_count so that it will be increased to
+ # $_history_substring_search_matches_count_plus.
+ #
+ if [[ $WIDGET == history-substring-search-down ]]; then
+ _history_substring_search_match_index=$_history_substring_search_matches_count
+ else
+ _history_substring_search_match_index=$_history_substring_search_matches_count_plus
+ fi
+ fi
+}
+
+function _history-substring-search-end() {
+ _history_substring_search_result=$BUFFER
+
+ # move the cursor to the end of the command line
+ if [[ $_history_substring_search_move_cursor_eol == true ]]; then
+ CURSOR=${#BUFFER}
+ fi
+
+ # highlight command line using zsh-syntax-highlighting
+ _zsh_highlight
+
+ # highlight the search query inside the command line
+ if [[ -n $_history_substring_search_query_highlight && -n $_history_substring_search_query ]]; then
+ #
+ # The following expression yields a variable $MBEGIN, which
+ # indicates the begin position + 1 of the first occurrence
+ # of _history_substring_search_query_escaped in $BUFFER.
+ #
+ : ${(S)BUFFER##(#m$HISTORY_SUBSTRING_SEARCH_GLOBBING_FLAGS)($_history_substring_search_query##)}
+ local begin=$(( MBEGIN - 1 ))
+ local end=$(( begin + $#_history_substring_search_query ))
+ region_highlight+=("$begin $end $_history_substring_search_query_highlight")
+ fi
+
+ # For debugging purposes:
+ # zle -R "mn: "$_history_substring_search_match_index" m#: "${#_history_substring_search_matches}
+ # read -k -t 200 && zle -U $REPLY
+
+ # Exit successfully from the history-substring-search-* widgets.
+ true
+}
+
+function _history-substring-search-up-buffer() {
+ #
+ # Check if the UP arrow was pressed to move the cursor within a multi-line
+ # buffer. This amounts to three tests:
+ #
+ # 1. $#buflines -gt 1.
+ #
+ # 2. $CURSOR -ne $#BUFFER.
+ #
+ # 3. Check if we are on the first line of the current multi-line buffer.
+ # If so, pressing UP would amount to leaving the multi-line buffer.
+ #
+ # We check this by adding an extra "x" to $LBUFFER, which makes
+ # sure that xlbuflines is always equal to the number of lines
+ # until $CURSOR (including the line with the cursor on it).
+ #
+ local buflines XLBUFFER xlbuflines
+ buflines=(${(f)BUFFER})
+ XLBUFFER=$LBUFFER"x"
+ xlbuflines=(${(f)XLBUFFER})
+
+ if [[ $#buflines -gt 1 && $CURSOR -ne $#BUFFER && $#xlbuflines -ne 1 ]]; then
+ zle up-line-or-history
+ return true
+ fi
+
+ false
+}
+
+function _history-substring-search-down-buffer() {
+ #
+ # Check if the DOWN arrow was pressed to move the cursor within a multi-line
+ # buffer. This amounts to three tests:
+ #
+ # 1. $#buflines -gt 1.
+ #
+ # 2. $CURSOR -ne $#BUFFER.
+ #
+ # 3. Check if we are on the last line of the current multi-line buffer.
+ # If so, pressing DOWN would amount to leaving the multi-line buffer.
+ #
+ # We check this by adding an extra "x" to $RBUFFER, which makes
+ # sure that xrbuflines is always equal to the number of lines
+ # from $CURSOR (including the line with the cursor on it).
+ #
+ local buflines XRBUFFER xrbuflines
+ buflines=(${(f)BUFFER})
+ XRBUFFER="x"$RBUFFER
+ xrbuflines=(${(f)XRBUFFER})
+
+ if [[ $#buflines -gt 1 && $CURSOR -ne $#BUFFER && $#xrbuflines -ne 1 ]]; then
+ zle down-line-or-history
+ return true
+ fi
+
+ false
+}
+
+function _history-substring-search-up-history() {
+ #
+ # Behave like up in ZSH, except clear the $BUFFER
+ # when beginning of history is reached like in Fish.
+ #
+ if [[ -z $_history_substring_search_query ]]; then
+
+ # we have reached the absolute top of history
+ if [[ $HISTNO -eq 1 ]]; then
+ BUFFER=
+
+ # going up from somewhere below the top of history
+ else
+ zle up-history
+ fi
+
+ return true
+ fi
+
+ false
+}
+
+function _history-substring-search-down-history() {
+ #
+ # Behave like down-history in ZSH, except clear the
+ # $BUFFER when end of history is reached like in Fish.
+ #
+ if [[ -z $_history_substring_search_query ]]; then
+
+ # going down from the absolute top of history
+ if [[ $HISTNO -eq 1 && -z $BUFFER ]]; then
+ BUFFER=${history[1]}
+ _history_substring_search_move_cursor_eol=true
+
+ # going down from somewhere above the bottom of history
+ else
+ zle down-history
+ fi
+
+ return true
+ fi
+
+ false
+}
+
+function _history-substring-search-up-search() {
+ _history_substring_search_move_cursor_eol=true
+
+ #
+ # Highlight matches during history-substring-up-search:
+ #
+ # The following constants have been initialized in
+ # _history-substring-search-up/down-search():
+ #
+ # $_history_substring_search_matches is the current list of matches
+ # $_history_substring_search_matches_count is the current number of matches
+ # $_history_substring_search_matches_count_plus is the current number of matches + 1
+ # $_history_substring_search_matches_count_sans is the current number of matches - 1
+ # $_history_substring_search_match_index is the index of the current match
+ #
+ # The range of values that $_history_substring_search_match_index can take
+ # is: [0, $_history_substring_search_matches_count_plus]. A value of 0
+ # indicates that we are beyond the end of
+ # $_history_substring_search_matches. A value of
+ # $_history_substring_search_matches_count_plus indicates that we are beyond
+ # the beginning of $_history_substring_search_matches.
+ #
+ # In _history-substring-search-up-search() the initial value of
+ # $_history_substring_search_match_index is
+ # $_history_substring_search_matches_count_plus. This value is set in
+ # _history-substring-search-begin(). _history-substring-search-up-search()
+ # will initially decrease it to $_history_substring_search_matches_count.
+ #
+ if [[ $_history_substring_search_match_index -ge 2 ]]; then
+ #
+ # Highlight the next match:
+ #
+ # 1. Decrease the value of $_history_substring_search_match_index.
+ #
+ # 2. Use $HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_FOUND
+ # to highlight the current buffer.
+ #
+ (( _history_substring_search_match_index-- ))
+ BUFFER=$history[$_history_substring_search_matches[$_history_substring_search_match_index]]
+ _history_substring_search_query_highlight=$HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_FOUND
+
+ elif [[ $_history_substring_search_match_index -eq 1 ]]; then
+ #
+ # We will move beyond the end of $_history_substring_search_matches:
+ #
+ # 1. Decrease the value of $_history_substring_search_match_index.
+ #
+ # 2. Save the current buffer in $_history_substring_search_old_buffer,
+ # so that it can be retrieved by
+ # _history-substring-search-down-search() later.
+ #
+ # 3. Make $BUFFER equal to $_history_substring_search_query.
+ #
+ # 4. Use $HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_NOT_FOUND
+ # to highlight the current buffer.
+ #
+ (( _history_substring_search_match_index-- ))
+ _history_substring_search_old_buffer=$BUFFER
+ BUFFER=$_history_substring_search_query
+ _history_substring_search_query_highlight=$HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_NOT_FOUND
+
+ elif [[ $_history_substring_search_match_index -eq $_history_substring_search_matches_count_plus ]]; then
+ #
+ # We were beyond the beginning of $_history_substring_search_matches but
+ # UP makes us move back to $_history_substring_search_matches:
+ #
+ # 1. Decrease the value of $_history_substring_search_match_index.
+ #
+ # 2. Restore $BUFFER from $_history_substring_search_old_buffer.
+ #
+ # 3. Use $HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_FOUND
+ # to highlight the current buffer.
+ #
+ (( _history_substring_search_match_index-- ))
+ BUFFER=$_history_substring_search_old_buffer
+ _history_substring_search_query_highlight=$HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_FOUND
+ fi
+}
+
+function _history-substring-search-down-search() {
+ _history_substring_search_move_cursor_eol=true
+
+ #
+ # Highlight matches during history-substring-up-search:
+ #
+ # The following constants have been initialized in
+ # _history-substring-search-up/down-search():
+ #
+ # $_history_substring_search_matches is the current list of matches
+ # $_history_substring_search_matches_count is the current number of matches
+ # $_history_substring_search_matches_count_plus is the current number of matches + 1
+ # $_history_substring_search_matches_count_sans is the current number of matches - 1
+ # $_history_substring_search_match_index is the index of the current match
+ #
+ # The range of values that $_history_substring_search_match_index can take
+ # is: [0, $_history_substring_search_matches_count_plus]. A value of 0
+ # indicates that we are beyond the end of
+ # $_history_substring_search_matches. A value of
+ # $_history_substring_search_matches_count_plus indicates that we are beyond
+ # the beginning of $_history_substring_search_matches.
+ #
+ # In _history-substring-search-down-search() the initial value of
+ # $_history_substring_search_match_index is
+ # $_history_substring_search_matches_count. This value is set in
+ # _history-substring-search-begin().
+ # _history-substring-search-down-search() will initially increase it to
+ # $_history_substring_search_matches_count_plus.
+ #
+ if [[ $_history_substring_search_match_index -le $_history_substring_search_matches_count_sans ]]; then
+ #
+ # Highlight the next match:
+ #
+ # 1. Increase $_history_substring_search_match_index by 1.
+ #
+ # 2. Use $HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_FOUND
+ # to highlight the current buffer.
+ #
+ (( _history_substring_search_match_index++ ))
+ BUFFER=$history[$_history_substring_search_matches[$_history_substring_search_match_index]]
+ _history_substring_search_query_highlight=$HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_FOUND
+
+ elif [[ $_history_substring_search_match_index -eq $_history_substring_search_matches_count ]]; then
+ #
+ # We will move beyond the beginning of $_history_substring_search_matches:
+ #
+ # 1. Increase $_history_substring_search_match_index by 1.
+ #
+ # 2. Save the current buffer in $_history_substring_search_old_buffer, so
+ # that it can be retrieved by _history-substring-search-up-search()
+ # later.
+ #
+ # 3. Make $BUFFER equal to $_history_substring_search_query.
+ #
+ # 4. Use $HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_NOT_FOUND
+ # to highlight the current buffer.
+ #
+ (( _history_substring_search_match_index++ ))
+ _history_substring_search_old_buffer=$BUFFER
+ BUFFER=$_history_substring_search_query
+ _history_substring_search_query_highlight=$HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_NOT_FOUND
+
+ elif [[ $_history_substring_search_match_index -eq 0 ]]; then
+ #
+ # We were beyond the end of $_history_substring_search_matches but DOWN
+ # makes us move back to the $_history_substring_search_matches:
+ #
+ # 1. Increase $_history_substring_search_match_index by 1.
+ #
+ # 2. Restore $BUFFER from $_history_substring_search_old_buffer.
+ #
+ # 3. Use $HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_FOUND
+ # to highlight the current buffer.
+ #
+ (( _history_substring_search_match_index++ ))
+ BUFFER=$_history_substring_search_old_buffer
+ _history_substring_search_query_highlight=$HISTORY_SUBSTRING_SEARCH_HIGHLIGHT_FOUND
+ fi
+}
+
+# -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
+# vim: ft=zsh sw=2 ts=2 et
diff --git a/plugins/kate/kate.plugin.zsh b/plugins/kate/kate.plugin.zsh
new file mode 100644
index 000000000..eb16522ac
--- /dev/null
+++ b/plugins/kate/kate.plugin.zsh
@@ -0,0 +1,9 @@
+
+# Kate
+# Start kate always silent
+alias kate='kate >/dev/null 2>&1'
+
+function kt () {
+ cd $1
+ kate $1
+} \ No newline at end of file
diff --git a/plugins/knife/_knife b/plugins/knife/_knife
new file mode 100644
index 000000000..7f8c95ee5
--- /dev/null
+++ b/plugins/knife/_knife
@@ -0,0 +1,174 @@
+#compdef knife
+
+# These flags should be available everywhere according to man knife
+knife_general_flags=( --help --server-url --key --config --editor --format --log_level --logfile --no-editor --user --print-after --version --yes )
+
+# knife has a very special syntax, some example calls are:
+# knife status
+# knife cookbook list
+# knife role show ROLENAME
+# knife data bag show DATABAGNAME
+# knife role show ROLENAME --attribute ATTRIBUTENAME
+# knife cookbook show COOKBOOKNAME COOKBOOKVERSION recipes
+
+# The -Q switch in compadd allow for completions of things like "data bag" without having to go through two rounds of completion and avoids zsh inserting a \ for escaping spaces
+_knife() {
+ local curcontext="$curcontext" state line
+ typeset -A opt_args
+ cloudproviders=(bluebox ec2 rackspace slicehost terremark)
+ _arguments \
+ '1: :->knifecmd'\
+ '2: :->knifesubcmd'\
+ '3: :->knifesubcmd2' \
+ '4: :->knifesubcmd3' \
+ '5: :->knifesubcmd4' \
+ '6: :->knifesubcmd5'
+
+ case $state in
+ knifecmd)
+ compadd -Q "$@" bootstrap client configure cookbook "cookbook site" "data bag" exec index node recipe role search ssh status windows $cloudproviders
+ ;;
+ knifesubcmd)
+ case $words[2] in
+ (bluebox|ec2|rackspace|slicehost|terremark)
+ compadd "$@" server images
+ ;;
+ client)
+ compadd -Q "$@" "bulk delete" list create show delete edit reregister
+ ;;
+ configure)
+ compadd "$@" client
+ ;;
+ cookbook)
+ compadd -Q "$@" test list create download delete "metadata from" show "bulk delete" metadata upload
+ ;;
+ node)
+ compadd -Q "$@" "from file" create show edit delete list run_list "bulk delete"
+ ;;
+ recipe)
+ compadd "$@" list
+ ;;
+ role)
+ compadd -Q "$@" "bulk delete" create delete edit "from file" list show
+ ;;
+ windows)
+ compadd "$@" bootstrap
+ ;;
+ *)
+ _arguments '2:Subsubcommands:($(_knife_options1))'
+ esac
+ ;;
+ knifesubcmd2)
+ case $words[3] in
+ server)
+ compadd "$@" list create delete
+ ;;
+ images)
+ compadd "$@" list
+ ;;
+ site)
+ compadd "$@" vendor show share search download list unshare
+ ;;
+ (show|delete|edit)
+ _arguments '3:Subsubcommands:($(_chef_$words[2]s_remote))'
+ ;;
+ (upload|test)
+ _arguments '3:Subsubcommands:($(_chef_$words[2]s_local) --all)'
+ ;;
+ list)
+ compadd -a "$@" knife_general_flags
+ ;;
+ bag)
+ compadd -Q "$@" show edit list "from file" create delete
+ ;;
+ *)
+ _arguments '3:Subsubcommands:($(_knife_options2))'
+ esac
+ ;;
+ knifesubcmd3)
+ case $words[3] in
+ show)
+ case $words[2] in
+ cookbook)
+ versioncomp=1
+ _arguments '4:Cookbookversions:($(_cookbook_versions) latest)'
+ ;;
+ (node|client|role)
+ compadd "$@" --attribute
+ esac
+ esac
+ case $words[4] in
+ (show|edit)
+ _arguments '4:Subsubsubcommands:($(_chef_$words[2]_$words[3]s_remote))'
+ ;;
+ file)
+ _arguments '*:file or directory:_files -g "*.(rb|json)"'
+ ;;
+ list)
+ compadd -a "$@" knife_general_flags
+ ;;
+ *)
+ _arguments '*:Subsubcommands:($(_knife_options3))'
+ esac
+ ;;
+ knifesubcmd4)
+ if (( versioncomp > 0 )); then
+ compadd "$@" attributes definitions files libraries providers recipes resources templates
+ else
+ _arguments '*:Subsubcommands:($(_knife_options2))'
+ fi
+ ;;
+ knifesubcmd5)
+ _arguments '*:Subsubcommands:($(_knife_options3))'
+ esac
+}
+
+# Helper functions to provide the argument completion for several depths of commands
+_knife_options1() {
+ ( for line in $( knife $words[2] --help | grep -v "^knife" ); do echo $line | grep "\-\-"; done )
+}
+
+_knife_options2() {
+ ( for line in $( knife $words[2] $words[3] --help | grep -v "^knife" ); do echo $line | grep "\-\-"; done )
+}
+
+_knife_options3() {
+ ( for line in $( knife $words[2] $words[3] $words[4] --help | grep -v "^knife" ); do echo $line | grep "\-\-"; done )
+}
+
+# The chef_x_remote functions use knife to get a list of objects of type x on the server
+_chef_roles_remote() {
+ (knife role list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+_chef_clients_remote() {
+ (knife client list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+_chef_nodes_remote() {
+ (knife node list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+_chef_cookbooks_remote() {
+ (knife cookbook list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+_chef_sitecookbooks_remote() {
+ (knife cookbook site list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+_chef_data_bags_remote() {
+ (knife data bag list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+# The chef_x_local functions use the knife config to find the paths of relevant objects x to be uploaded to the server
+_chef_cookbooks_local() {
+ (for i in $( grep cookbook_path $HOME/.chef/knife.rb | awk 'BEGIN {FS = "[" }; {print $2}' | sed 's/\,//g' | sed "s/'//g" | sed 's/\(.*\)]/\1/' ); do ls $i; done)
+}
+
+# This function extracts the available cookbook versions on the chef server
+_cookbook_versions() {
+ (knife cookbook show $words[4] | grep -v $words[4] | grep -v -E '\]|\[|\{|\}' | sed 's/ //g' | sed 's/"//g')
+}
+
+_knife "$@"
diff --git a/plugins/lol/lol.plugin.zsh b/plugins/lol/lol.plugin.zsh
index a7153bb57..e455527e7 100644
--- a/plugins/lol/lol.plugin.zsh
+++ b/plugins/lol/lol.plugin.zsh
@@ -8,19 +8,30 @@ alias rtfm='man'
alias visible='echo'
alias invisible='cat'
alias moar='more'
+alias tldr='less'
+alias alwayz='tail -f'
alias icanhas='mkdir'
+alias gimmeh='touch'
alias donotwant='rm'
alias dowant='cp'
alias gtfo='mv'
+alias nowai='chmod'
alias hai='cd'
+alias iz='ls'
alias plz='pwd'
+alias ihasbucket='df -h'
alias inur='locate'
+alias iminurbase='finger'
+
+alias btw='nice'
+alias obtw='nohup'
alias nomz='ps -aux'
alias nomnom='killall'
+alias byes='exit'
alias cya='reboot'
alias kthxbai='halt'
diff --git a/plugins/node/node.plugin.zsh b/plugins/node/node.plugin.zsh
new file mode 100644
index 000000000..519bc18da
--- /dev/null
+++ b/plugins/node/node.plugin.zsh
@@ -0,0 +1,5 @@
+# Open the node api for your current version to the optional section.
+# TODO: Make the section part easier to use.
+function node-docs {
+ open "http://nodejs.org/docs/$(node --version)/api/all.html#$1"
+}
diff --git a/plugins/npm/_npm b/plugins/npm/_npm
deleted file mode 100644
index 24b536188..000000000
--- a/plugins/npm/_npm
+++ /dev/null
@@ -1,19 +0,0 @@
-#compdef npm
-
-# Node Package Manager 0.3.15 completion, letting npm do all the completion work
-
-_npm() {
- compadd -- $(_npm_complete $words)
-}
-
-# We want to show all errors of any substance, but never the "npm (not )ok" one.
-# (Also doesn't consider "ERR! no match found" worth breaking the terminal for.)
-_npm_complete() {
- local ask_npm
- ask_npm=(npm completion --color false --loglevel error -- $@)
- { _call_program npm $ask_npm 2>&1 >&3 \
- | egrep -v '^(npm (not |)ok|ERR! no match found)$' >&2; \
- } 3>&1
-}
-
-_npm "$@"
diff --git a/plugins/npm/npm.plugin.zsh b/plugins/npm/npm.plugin.zsh
new file mode 100644
index 000000000..c3eb91d31
--- /dev/null
+++ b/plugins/npm/npm.plugin.zsh
@@ -0,0 +1 @@
+eval "$(npm completion 2>/dev/null)"
diff --git a/plugins/osx/_man-preview b/plugins/osx/_man-preview
new file mode 100644
index 000000000..6cc344ad4
--- /dev/null
+++ b/plugins/osx/_man-preview
@@ -0,0 +1,5 @@
+#compdef man-preview
+#autoload
+
+_man
+
diff --git a/plugins/osx/osx.plugin.zsh b/plugins/osx/osx.plugin.zsh
index 81eed5e92..682bb2667 100644
--- a/plugins/osx/osx.plugin.zsh
+++ b/plugins/osx/osx.plugin.zsh
@@ -1,57 +1,99 @@
-function savepath() {
- pwd > ~/.current_path~
-}
+# ------------------------------------------------------------------------------
+# FILE: osx.plugin.zsh
+# DESCRIPTION: oh-my-zsh plugin file.
+# AUTHOR: Sorin Ionescu (sorin.ionescu@gmail.com)
+# VERSION: 1.0.1
+# ------------------------------------------------------------------------------
+
function tab() {
-savepath
-osascript >/dev/null <<EOF
-on do_submenu(app_name, menu_name, menu_item, submenu_item)
- -- bring the target application to the front
- tell application app_name
- activate
- end tell
- tell application "System Events"
- tell process app_name
- tell menu bar 1
- tell menu bar item menu_name
- tell menu menu_name
- tell menu item menu_item
- tell menu menu_item
- click menu item submenu_item
- end tell
- end tell
- end tell
- end tell
- end tell
+ local command="cd \\\"$PWD\\\""
+ (( $# > 0 )) && command="${command}; $*"
+
+ the_app=$(
+ osascript 2>/dev/null <<EOF
+ tell application "System Events"
+ name of first item of (every process whose frontmost is true)
end tell
- end tell
-end do_submenu
+EOF
+ )
-do_submenu("Terminal", "Shell", "New Tab", 1)
+ [[ "$the_app" == 'Terminal' ]] && {
+ osascript 2>/dev/null <<EOF
+ tell application "System Events"
+ tell process "Terminal" to keystroke "t" using command down
+ tell application "Terminal" to do script "${command}" in front window
+ end tell
EOF
-}
+ }
-function itab() {
-savepath
-osascript >/dev/null <<EOF
-on do_submenu(app_name, menu_name, menu_item)
- -- bring the target application to the front
- tell application app_name
- activate
- end tell
- tell application "System Events"
- tell process app_name
- tell menu bar 1
- tell menu bar item menu_name
- tell menu menu_name
- click menu item menu_item
- end tell
+ [[ "$the_app" == 'iTerm' ]] && {
+ osascript 2>/dev/null <<EOF
+ tell application "iTerm"
+ set current_terminal to current terminal
+ tell current_terminal
+ launch session "Default Session"
+ set current_session to current session
+ tell current_session
+ write text "${command}"
end tell
end tell
end tell
+EOF
+ }
+}
+
+function pfd() {
+ osascript 2>/dev/null <<EOF
+ tell application "Finder"
+ return POSIX path of (target of window 1 as alias)
end tell
-end do_submenu
+EOF
+}
-do_submenu("iTerm", "Shell", "New Tab")
+function pfs() {
+ osascript 2>/dev/null <<EOF
+ set output to ""
+ tell application "Finder" to set the_selection to selection
+ set item_count to count the_selection
+ repeat with item_index from 1 to count the_selection
+ if item_index is less than item_count then set the_delimiter to "\n"
+ if item_index is item_count then set the_delimiter to ""
+ set output to output & ((item item_index of the_selection as alias)'s POSIX path) & the_delimiter
+ end repeat
EOF
}
+
+function cdf() {
+ cd "$(pfd)"
+}
+
+function pushdf() {
+ pushd "$(pfd)"
+}
+
+function quick-look() {
+ (( $# > 0 )) && qlmanage -p $* &>/dev/null &
+}
+
+function man-preview() {
+ man -t "$@" | open -f -a Preview
+}
+
+function trash() {
+ local trash_dir="${HOME}/.Trash"
+ local temp_ifs=$IFS
+ IFS=$'\n'
+ for item in "$@"; do
+ if [[ -e "$item" ]]; then
+ item_name="$(basename $item)"
+ if [[ -e "${trash_dir}/${item_name}" ]]; then
+ mv -f "$item" "${trash_dir}/${item_name} $(date "+%H-%M-%S")"
+ else
+ mv -f "$item" "${trash_dir}/"
+ fi
+ fi
+ done
+ IFS=$temp_ifs
+}
+
diff --git a/plugins/phing/phing.plugin.zsh b/plugins/phing/phing.plugin.zsh
index 80e334629..8f4adca08 100644
--- a/plugins/phing/phing.plugin.zsh
+++ b/plugins/phing/phing.plugin.zsh
@@ -10,7 +10,6 @@ _phing_does_target_list_need_generating () {
_phing () {
if [ -f build.xml ]; then
if _phing_does_target_list_need_generating; then
- echo "\nGenerating .phing_targets..." > /dev/stderr
phing -l |grep -v ":" |grep -v "^$"|grep -v "\-" > .phing_targets
fi
compadd `cat .phing_targets`
diff --git a/plugins/pow/pow.plugin.zsh b/plugins/pow/pow.plugin.zsh
new file mode 100644
index 000000000..6b2a6f2be
--- /dev/null
+++ b/plugins/pow/pow.plugin.zsh
@@ -0,0 +1,10 @@
+# Thanks to Christopher Sexton
+# https://gist.github.com/965032
+function kapow {
+ touch ~/.pow/$1/tmp/restart.txt
+ if [ $? -eq 0 ]; then
+ echo "$fg[yellow]Pow restarting $1...$reset_color"
+ fi
+}
+
+compctl -W ~/.pow -/ kapow
diff --git a/plugins/powder/_powder b/plugins/powder/_powder
new file mode 100644
index 000000000..84e260a15
--- /dev/null
+++ b/plugins/powder/_powder
@@ -0,0 +1,4 @@
+#compdef powder
+#autoload
+
+compadd `powder help | grep powder | cut -d " " -f 4`
diff --git a/plugins/python/python.plugin.zsh b/plugins/python/python.plugin.zsh
new file mode 100644
index 000000000..3ea34d718
--- /dev/null
+++ b/plugins/python/python.plugin.zsh
@@ -0,0 +1,5 @@
+# Find python file
+alias pyfind='find . -name "*.py"'
+
+# Remove python compiled byte-code
+alias pyclean='find . -type f -name "*.py[co]" -exec rm -f \{\} \;'
diff --git a/plugins/rails3/rails3.plugin.zsh b/plugins/rails3/rails3.plugin.zsh
index f669ef047..f4ee637e6 100644
--- a/plugins/rails3/rails3.plugin.zsh
+++ b/plugins/rails3/rails3.plugin.zsh
@@ -1,13 +1,5 @@
# Rails 3 aliases, backwards-compatible with Rails 2.
-function _bundle_command {
- if command -v bundle && [ -e "Gemfile" ]; then
- bundle exec $@
- else
- $@
- fi
-}
-
function _rails_command () {
if [ -e "script/server" ]; then
ruby script/$@
@@ -25,6 +17,3 @@ alias rp='_rails_command plugin'
alias rs='_rails_command server'
alias rsd='_rails_command server --debugger'
alias devlog='tail -f log/development.log'
-
-alias rspec='_bundle_command rspec'
-alias cuke='_bundle_command cucumber'
diff --git a/plugins/redis-cli/_redis-cli b/plugins/redis-cli/_redis-cli
index 3789add18..1569f2916 100644
--- a/plugins/redis-cli/_redis-cli
+++ b/plugins/redis-cli/_redis-cli
@@ -51,7 +51,7 @@ _1st_arguments=(
'keys:find all keys matching the given pattern'
'lastsave:get the UNIX timestamp of the last successful save to disk'
'lindex:get an element from a list by its index'
- 'linset:insert an element before or after another element in a list'
+ 'linsert:insert an element before or after another element in a list'
'llen:get the length of a list'
'lpop:remove and get the first element in a list'
'lpush:prepend a value to a list'
diff --git a/plugins/ruby/ruby.plugin.zsh b/plugins/ruby/ruby.plugin.zsh
index 82bf5d49d..08ca9c601 100644
--- a/plugins/ruby/ruby.plugin.zsh
+++ b/plugins/ruby/ruby.plugin.zsh
@@ -1,4 +1,6 @@
+# TODO: Make this compatible with rvm.
+# Run sudo gem on the system ruby, not the active ruby.
alias sgem='sudo gem'
# Find ruby file
-alias rfind='find . -name *.rb | xargs grep -n' \ No newline at end of file
+alias rfind='find . -name *.rb | xargs grep -n'
diff --git a/plugins/rvm/_rvm b/plugins/rvm/_rvm
new file mode 100644
index 000000000..bba5304a0
--- /dev/null
+++ b/plugins/rvm/_rvm
@@ -0,0 +1,147 @@
+#compdef rvm
+
+local curcontext="$curcontext" state line cmds ret=1
+
+_arguments -C \
+ '(- 1 *)'{-v,--version}'[display version information]' \
+ '(-l|--level)'{-l,--level}'+[patch level to use with rvm use / install]:number' \
+ '(--prefix)--prefix[path for all rvm files (~/.rvm/), with trailing slash!]:path:_files' \
+ '(--bin)--bin[path for binaries to be placed (~/.rvm/bin/)]:path:_files' \
+ '(--source)--source[src directory to use (~/.rvm/src/)]:path:_files' \
+ '(--archives)--archives[directory for downladed files (~/.rvm/archives/)]:path:_files' \
+ '-S[Specify a script file to attempt to load and run (rubydo)]:file:_files' \
+ '-e[Execute code from the command line]:code' \
+ '(-G)-G[root gem path to use]:path:_files' \
+ '(--gems)--gems[Used to set the gems_flag, use with remove to remove gems]' \
+ '(--archive)--archive[Used to set the archive_flag, use with remove to remove archive]' \
+ '(--patch)--patch[With MRI Rubies you may specify one or more full paths to patches]' \
+ '(-C|--configure)'{-C,--configure}'=[custom configure options]' \
+ '(--nice)--nice[process niceness (for slow computers, default 0)]:number' \
+ '(--ree)--ree-options[Options passed directly to ree ./installer on the command line]:options' \
+ '(--head)--head[with update, updates rvm to git head version]' \
+ '(--rubygems)--rubygems[with update, updates rubygems for selected ruby]' \
+ '(--default)--default[with ruby select, sets a default ruby for new shells]' \
+ '(--debug)--debug[Toggle debug mode on for very verbose output]' \
+ '(--trace)--trace[Toggle trace mode on to see EVERYTHING rvm is doing]' \
+ '(--force)--force[Force install, removes old install & source before install]' \
+ '(--summary)--summary[Used with rubydo to print out a summary of the commands run]' \
+ '(--latest)--latest[with gemset --dump skips version strings for latest gem]' \
+ '(--gems)--gems[with uninstall/remove removes gems with the interpreter]' \
+ '(--docs)--docs[with install, attempt to generate ri after installation]' \
+ '(--reconfigure)--reconfigure[Force ./configure on install even if Makefile already exists]' \
+ '1: :->cmds' \
+ '*: :->args' && ret=0
+
+case $state in
+ cmds)
+ cmds=(
+ "version:show the rvm version installed in rvm_path"
+ "use:setup current shell to use a specific ruby version"
+ "reload:reload rvm source itself (useful after changing rvm source)"
+ "implode:(seppuku) removes the rvm installation completely. This means everything in $rvm_path (~/.rvm)."
+ "update:upgrades rvm to the latest version."
+ "reset:remove current and stored default & system settings."
+ "info :show the *current* environment information for current ruby"
+ "current:print the *current* ruby version and the name of any gemset being used."
+ "debug:show info plus additional information for common issues"
+ "install:install one or many ruby versions"
+ "uninstall:uninstall one or many ruby versions, leaves their sources"
+ "remove:uninstall one or many ruby versions and remove their sources"
+ "migrate:Lets you migrate all gemsets from one ruby to another."
+ "upgrade:Lets you upgrade from one version of a ruby to another, including migrating your gemsets semi-automatically."
+ "wrapper:generates a set of wrapper executables for a given ruby with the specified ruby and gemset combination. Used under the hood for passenger support and the like."
+ "cleanup:Lets you remove stale source folders / archives and other miscellaneous data associated with rvm."
+ "repair:Lets you repair parts of your environment e.g. wrappers, env files and and similar files (e.g. general maintenance)."
+ "snapshot:Lets your backup / restore an rvm installation in a lightweight manner."
+ "disk-usage:Tells you how much disk space rvm install is using."
+ "tools:Provides general information about the ruby environment, primarily useful when scripting rvm."
+ "docs:Tools to make installing ri and rdoc documentation easier."
+ "rvmrc:Tools related to managing rvmrc trust and loading."
+ "exec:runs an arbitrary command as a set operation."
+ "ruby:runs a named ruby file against specified and/or all rubies"
+ "gem:runs a gem command using selected ruby's 'gem'"
+ "rake:runs a rake task against specified and/or all rubies"
+ "tests:runs 'rake test' across selected ruby versions"
+ "specs:runs 'rake spec' across selected ruby versions"
+ "monitor:Monitor cwd for testing, run rake {spec,test} on changes."
+ "gemset:gemsets: http://rvm.beginrescueend.com/gemsets/"
+ "rubygems:Switches the installed version of rubygems for the current ruby."
+ "gemdir:display the path to the current gem directory (GEM_HOME)."
+ "srcdir:display the path to rvm source directory (may be yanked)"
+ "fetch:Performs an archive / src fetch only of the selected ruby."
+ "list:show currently installed rubies, interactive output."
+ "package:Install a dependency package {readline,iconv,zlib,openssl}"
+ "notes:Display notes, with operating system specifics."
+ "export:Temporarily set an environment variable in the current shell."
+ "unexport:Undo changes made to the environment by 'rvm export'."
+ )
+ _describe -t commands 'rvm command' cmds && ret=0
+ ;;
+ args)
+ case $line[1] in
+ (use|uninstall|remove|list)
+ _values -S , 'rubies' $(rvm list strings | sed -e 's/ruby-\([^) ]*\)-\([^) ]*\)/ruby-\1-\2 \1-\2 \1/g') default system && ret=0
+ ;;
+ (install|fetch)
+ _values -S , 'rubies' $(rvm list known_strings) && ret=0
+ ;;
+ gemset)
+ if (( CURRENT == 3 )); then
+ _values 'gemset_commands' \
+ 'import' \
+ 'export' \
+ 'create' \
+ 'copy' \
+ 'rename' \
+ 'empty' \
+ 'delete' \
+ 'name' \
+ 'dir' \
+ 'list' \
+ 'list_all' \
+ 'gemdir' \
+ 'install' \
+ 'pristine' \
+ 'clear' \
+ 'use' \
+ 'update' \
+ 'unpack' \
+ 'globalcache'
+ else
+ _values -S , 'gemsets' $(rvm gemset list | grep -v gemset 2>/dev/null)
+ fi
+ ret=0
+ ;;
+ package)
+ if (( CURRENT == 3 )); then
+ _values 'package_commands' \
+ 'install' \
+ 'uninstall'
+ else
+ _values 'packages' \
+ 'readline' \
+ 'iconv' \
+ 'curl' \
+ 'openssl' \
+ 'zlib' \
+ 'autoconf' \
+ 'ncurses' \
+ 'pkgconfig' \
+ 'gettext' \
+ 'glib' \
+ 'mono' \
+ 'llvm' \
+ 'libxml2' \
+ 'libxslt' \
+ 'libyaml'
+ fi
+ ret=0
+ ;;
+ *)
+ (( ret )) && _message 'no more arguments'
+ ;;
+ esac
+ ;;
+esac
+
+return ret
diff --git a/plugins/rvm/rvm.plugin.zsh b/plugins/rvm/rvm.plugin.zsh
new file mode 100644
index 000000000..24621fe0b
--- /dev/null
+++ b/plugins/rvm/rvm.plugin.zsh
@@ -0,0 +1,44 @@
+alias rubies='rvm list rubies'
+alias gemsets='rvm gemset list'
+
+local ruby18='ruby-1.8.7-p334'
+local ruby19='ruby-1.9.2-p180'
+
+function rb18 {
+ if [ -z "$1" ]; then
+ rvm use "$ruby18"
+ else
+ rvm use "$ruby18@$1"
+ fi
+}
+
+_rb18() {compadd `ls -1 $rvm_path/gems | grep "^$ruby18@" | sed -e "s/^$ruby18@//" | awk '{print $1}'`}
+compdef _rb18 rb18
+
+function rb19 {
+ if [ -z "$1" ]; then
+ rvm use "$ruby19"
+ else
+ rvm use "$ruby19@$1"
+ fi
+}
+
+_rb19() {compadd `ls -1 $rvm_path/gems | grep "^$ruby19@" | sed -e "s/^$ruby19@//" | awk '{print $1}'`}
+compdef _rb19 rb19
+
+function rvm-update {
+ rvm get head
+ rvm reload # TODO: Reload rvm completion?
+}
+
+# TODO: Make this usable w/o rvm.
+function gems {
+ local current_ruby=`rvm-prompt i v p`
+ local current_gemset=`rvm-prompt g`
+
+ gem list $@ | sed \
+ -Ee "s/\([0-9\.]+( .+)?\)/$fg[blue]&$reset_color/g" \
+ -Ee "s|$(echo $rvm_path)|$fg[magenta]\$rvm_path$reset_color|g" \
+ -Ee "s/$current_ruby@global/$fg[yellow]&$reset_color/g" \
+ -Ee "s/$current_ruby$current_gemset$/$fg[green]&$reset_color/g"
+}
diff --git a/plugins/ssh-agent/ssh-agent.plugin.zsh b/plugins/ssh-agent/ssh-agent.plugin.zsh
index 0efc4546f..c4e92a1fe 100644
--- a/plugins/ssh-agent/ssh-agent.plugin.zsh
+++ b/plugins/ssh-agent/ssh-agent.plugin.zsh
@@ -1,23 +1,62 @@
-# Based on code from Joseph M. Reagle
-# http://www.cygwin.com/ml/cygwin/2001-06/msg00537.html
+#
+# INSTRUCTIONS
+#
+# To enabled agent forwarding support add the following to
+# your .zshrc file:
+#
+# zstyle :omz:plugins:ssh-agent agent-forwarding on
+#
+# To load multiple identies use the identities style, For
+# example:
+#
+# zstyle :omz:plugins:ssh-agent id_rsa id_rsa2 id_github
+#
+#
+# CREDITS
+#
+# Based on code from Joseph M. Reagle
+# http://www.cygwin.com/ml/cygwin/2001-06/msg00537.html
+#
+# Agent forwarding support based on ideas from
+# Florent Thoumie and Jonas Pfenniger
+#
-local SSH_ENV=$HOME/.ssh/environment-$HOST
+local _plugin__ssh_env=$HOME/.ssh/environment-$HOST
+local _plugin__forwarding
-function start_agent {
- /usr/bin/env ssh-agent | sed 's/^echo/#echo/' > ${SSH_ENV}
- chmod 600 ${SSH_ENV}
- . ${SSH_ENV} > /dev/null
- /usr/bin/ssh-add;
+function _plugin__start_agent()
+{
+ local -a identities
+
+ # start ssh-agent and setup environment
+ /usr/bin/env ssh-agent | sed 's/^echo/#echo/' > ${_plugin__ssh_env}
+ chmod 600 ${_plugin__ssh_env}
+ . ${_plugin__ssh_env} > /dev/null
+
+ # load identies
+ zstyle -a :omz:plugins:ssh-agent identities identities
+ echo starting...
+ /usr/bin/ssh-add $HOME/.ssh/${^identities}
}
-# Source SSH settings, if applicable
+# test if agent-forwarding is enabled
+zstyle -b :omz:plugins:ssh-agent agent-forwarding _plugin__forwarding
+if [[ ${_plugin__forwarding} == "yes" && -n "$SSH_AUTH_SOCK" ]]; then
+ # Add a nifty symlink for screen/tmux if agent forwarding
+ [[ -L $SSH_AUTH_SOCK ]] || ln -sf "$SSH_AUTH_SOCK" /tmp/ssh-agent-$USER-screen
-if [ -f "${SSH_ENV}" ]; then
- . ${SSH_ENV} > /dev/null
+elif [ -f "${_plugin__ssh_env}" ]; then
+ # Source SSH settings, if applicable
+ . ${_plugin__ssh_env} > /dev/null
ps -ef | grep ${SSH_AGENT_PID} | grep ssh-agent$ > /dev/null || {
- start_agent;
+ _plugin__start_agent;
}
else
- start_agent;
+ _plugin__start_agent;
fi
+# tidy up after ourselves
+unfunction _plugin__start_agent
+unset _plugin__forwarding
+unset _plugin__ssh_env
+
diff --git a/plugins/svn/svn.plugin.zsh b/plugins/svn/svn.plugin.zsh
index 45d461306..53a8a513a 100644
--- a/plugins/svn/svn.plugin.zsh
+++ b/plugins/svn/svn.plugin.zsh
@@ -1,5 +1,5 @@
function svn_prompt_info {
- if [[ -d .svn ]]; then
+ if [ in_svn ]; then
echo "$ZSH_PROMPT_BASE_COLOR$ZSH_THEME_SVN_PROMPT_PREFIX\
$ZSH_THEME_REPO_NAME_COLOR$(svn_get_repo_name)$ZSH_PROMPT_BASE_COLOR$ZSH_THEME_SVN_PROMPT_SUFFIX$ZSH_PROMPT_BASE_COLOR$(svn_dirty)$ZSH_PROMPT_BASE_COLOR"
fi
@@ -13,7 +13,7 @@ function in_svn() {
}
function svn_get_repo_name {
- if [ is_svn ]; then
+ if [ in_svn ]; then
svn info | sed -n 's/Repository\ Root:\ .*\///p' | read SVN_ROOT
svn info | sed -n "s/URL:\ .*$SVN_ROOT\///p" | sed "s/\/.*$//"
@@ -21,14 +21,14 @@ function svn_get_repo_name {
}
function svn_get_rev_nr {
- if [ is_svn ]; then
+ if [ in_svn ]; then
svn info 2> /dev/null | sed -n s/Revision:\ //p
fi
}
function svn_dirty_choose {
- if [ is_svn ]; then
- s=$(svn status 2>/dev/null)
+ if [ in_svn ]; then
+ s=$(svn status|grep -E '^\s*[ACDIM!?L]' 2>/dev/null)
if [ $s ]; then
echo $1
else
@@ -39,4 +39,4 @@ function svn_dirty_choose {
function svn_dirty {
svn_dirty_choose $ZSH_THEME_SVN_PROMPT_DIRTY $ZSH_THEME_SVN_PROMPT_CLEAN
-} \ No newline at end of file
+}
diff --git a/plugins/taskwarrior/_task b/plugins/taskwarrior/_task
new file mode 100644
index 000000000..5bffa9119
--- /dev/null
+++ b/plugins/taskwarrior/_task
@@ -0,0 +1,280 @@
+#compdef task
+#
+# zsh completion for taskwarrior
+#
+# Copyright 2010 - 2011 Johannes Schlatow
+# Copyright 2009 P.C. Shyamshankar
+# All rights reserved.
+#
+# This script is part of the taskwarrior project.
+#
+# This program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation; either version 2 of the License, or (at your option) any later
+# version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the
+#
+# Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor,
+# Boston, MA
+# 02110-1301
+# USA
+#
+typeset -g _task_cmds _task_projects _task_tags _task_config _task_modifiers
+_task_projects=($(task _projects))
+_task_tags=($(task _tags))
+_task_ids=($(task _ids))
+_task_config=($(task _config))
+_task_modifiers=(
+ 'before' \
+ 'after' \
+ 'none' \
+ 'any' \
+ 'is' \
+ 'isnt' \
+ 'has' \
+ 'hasnt' \
+ 'startswith' \
+ 'endswith' \
+ 'word' \
+ 'noword'
+)
+_task_cmds=($(task _commands))
+_task_zshcmds=( ${(f)"$(task _zshcommands)"} )
+
+
+_task_idCmds=(
+ 'append' \
+ 'prepend' \
+ 'annotate' \
+ 'denotate' \
+ 'edit' \
+ 'duplicate' \
+ 'info' \
+ 'start' \
+ 'stop' \
+ 'done'
+)
+
+_task_idCmdsDesc=(
+ 'append:Appends more description to an existing task.' \
+ 'prepend:Prepends more description to an existing task.' \
+ 'annotate:Adds an annotation to an existing task.' \
+ 'denotate:Deletes an annotation of an existing task.' \
+ 'edit:Launches an editor to let you modify a task directly.' \
+ 'duplicate:Duplicates the specified task, and allows modifications.' \
+ 'info:Shows all data, metadata for specified task.' \
+ 'start:Marks specified task as started.' \
+ 'stop:Removes the start time from a task.' \
+ 'done:Marks the specified task as completed.'
+)
+
+_task() {
+ _arguments -s -S \
+ "*::task command:_task_commands"
+ return 0
+}
+
+local -a reply args word
+word=$'[^\0]#\0'
+
+# priorities
+local -a task_priorities
+_regex_words values 'task priorities' \
+ 'H:High' \
+ 'M:Middle' \
+ 'L:Low'
+task_priorities=("$reply[@]")
+
+# projects
+local -a task_projects
+task_projects=(
+ /"$word"/
+ ":values:task projects:compadd -a _task_projects"
+)
+
+local -a _task_dates
+_regex_words values 'task dates' \
+ 'tod*ay:Today' \
+ 'yes*terday:Yesterday' \
+ 'tom*orrow:Tomorrow' \
+ 'sow:Start of week' \
+ 'soww:Start of work week' \
+ 'socw:Start of calendar week' \
+ 'som:Start of month' \
+ 'soy:Start of year' \
+ 'eow:End of week' \
+ 'eoww:End of work week' \
+ 'eocw:End of calendar week' \
+ 'eom:End of month' \
+ 'eoy:End of year' \
+ 'mon:Monday' \
+ 'tue:Tuesday'\
+ 'wed:Wednesday' \
+ 'thu:Thursday' \
+ 'fri:Friday' \
+ 'sat:Saturday' \
+ 'sun:Sunday'
+_task_dates=("$reply[@]")
+
+local -a _task_reldates
+_regex_words values 'task reldates' \
+ 'hrs:n hours' \
+ 'day:n days' \
+ '1st:first' \
+ '2nd:second' \
+ '3rd:third' \
+ 'th:4th, 5th, etc.' \
+ 'wks:weeks'
+_task_reldates=("$reply[@]")
+
+task_dates=(
+ \( "$_task_dates[@]" \|
+ \( /$'[0-9][0-9]#'/- \( "$_task_reldates[@]" \) \)
+ \)
+)
+
+_regex_words values 'task frequencies' \
+ 'daily:Every day' \
+ 'day:Every day' \
+ 'weekdays:Every day skipping weekend days' \
+ 'weekly:Every week' \
+ 'biweekly:Every two weeks' \
+ 'fortnight:Every two weeks' \
+ 'quarterly:Every three months' \
+ 'semiannual:Every six months' \
+ 'annual:Every year' \
+ 'yearly:Every year' \
+ 'biannual:Every two years' \
+ 'biyearly:Every two years'
+_task_freqs=("$reply[@]")
+
+local -a _task_frequencies
+_regex_words values 'task frequencies' \
+ 'd:days' \
+ 'w:weeks' \
+ 'q:quarters' \
+ 'y:years'
+_task_frequencies=("$reply[@]")
+
+task_freqs=(
+ \( "$_task_freqs[@]" \|
+ \( /$'[0-9][0-9]#'/- \( "$_task_frequencies[@]" \) \)
+ \)
+)
+
+# attributes
+local -a task_attributes
+_regex_words -t ':' default 'task attributes' \
+ 'pro*ject:Project name:$task_projects' \
+ 'du*e:Due date:$task_dates' \
+ 'wa*it:Date until task becomes pending:$task_dates' \
+ 're*cur:Recurrence frequency:$task_freqs' \
+ 'pri*ority:priority:$task_priorities' \
+ 'un*til:Recurrence end date:$task_dates' \
+ 'fg:Foreground color' \
+ 'bg:Background color' \
+ 'li*mit:Desired number of rows in report'
+task_attributes=("$reply[@]")
+
+args=(
+ \( "$task_attributes[@]" \|
+ \( /'(project|due|wait|recur|priority|until|fg|bg|limit).'/- \( /$'[^:]#:'/ ":default:modifiers:compadd -S ':' -a _task_modifiers" \) \) \|
+ \( /'(rc).'/- \( /$'[^:]#:'/ ":arguments:config:compadd -S ':' -a _task_config" \) \) \|
+ \( /'(+|-)'/- \( /"$word"/ ":values:remove tag:compadd -a _task_tags" \) \) \|
+ \( /"$word"/ \)
+ \) \#
+)
+_regex_arguments _task_attributes "${args[@]}"
+
+## task commands
+
+# default completion
+(( $+functions[_task_default] )) ||
+_task_default() {
+ _task_attributes "$@"
+}
+
+# commands expecting an ID
+(( $+functions[_task_id] )) ||
+_task_id() {
+ if (( CURRENT < 3 )); then
+ # update IDs
+ _task_zshids=( ${(f)"$(task _zshids)"} )
+ _describe -t values 'task IDs' _task_zshids
+ else
+ _task_attributes "$@"
+ fi
+}
+
+# merge completion
+(( $+functions[_task_merge] )) ||
+_task_merge() {
+ # TODO match URIs in .taskrc
+ _files
+}
+
+# push completion
+(( $+functions[_task_push] )) ||
+_task_push() {
+ # TODO match URIs in .taskrc
+ _files
+}
+
+# pull completion
+(( $+functions[_task_pull] )) ||
+_task_pull() {
+ # TODO match URIs in .taskrc
+ _files
+}
+
+
+# modify (task [0-9]* ...) completion
+(( $+functions[_task_modify] )) ||
+_task_modify() {
+ _describe -t commands 'task command' _task_idCmdsDesc
+ _task_attributes "$@"
+}
+
+## first level completion => task sub-command completion
+(( $+functions[_task_commands] )) ||
+_task_commands() {
+ local cmd ret=1
+ if (( CURRENT == 1 )); then
+ # update IDs
+ _task_zshids=( ${(f)"$(task _zshids)"} )
+
+ _describe -t commands 'task command' _task_zshcmds
+ _describe -t values 'task IDs' _task_zshids
+ # TODO match more than one ID
+ elif [[ $words[1] =~ ^[0-9]*$ ]] then
+ _call_function ret _task_modify
+ return ret
+ else
+# local curcontext="${curcontext}"
+# cmd="${_task_cmds[(r)$words[1]:*]%%:*}"
+ cmd="${_task_cmds[(r)$words[1]]}"
+ idCmd="${(M)_task_idCmds[@]:#$words[1]}"
+ if (( $#cmd )); then
+# curcontext="${curcontext%:*:*}:task-${cmd}"
+
+ if (( $#idCmd )); then
+ _call_function ret _task_id
+ else
+ _call_function ret _task_${cmd} ||
+ _call_function ret _task_default ||
+ _message "No command remaining."
+ fi
+ else
+ _message "Unknown subcommand ${cmd}"
+ fi
+ return ret
+ fi
+}
diff --git a/plugins/taskwarrior/taskwarrior.plugin.zsh b/plugins/taskwarrior/taskwarrior.plugin.zsh
new file mode 100644
index 000000000..c1830042e
--- /dev/null
+++ b/plugins/taskwarrior/taskwarrior.plugin.zsh
@@ -0,0 +1,21 @@
+################################################################################
+# Author: Pete Clark
+# Email: pete[dot]clark[at]gmail[dot]com
+# Version: 0.1 (05/24/2011)
+# License: WTFPL<http://sam.zoy.org/wtfpl/>
+#
+# This oh-my-zsh plugin adds smart tab completion for
+# TaskWarrior<http://taskwarrior.org/>. It uses the zsh tab completion
+# script (_task) distributed with TaskWarrior for the completion definitions.
+#
+# Typing task[tabtab] will give you a list of current tasks, task 66[tabtab]
+# gives a list of available modifications for that task, etc.
+################################################################################
+
+zstyle ':completion:*:*:task:*' verbose yes
+zstyle ':completion:*:*:task:*:descriptions' format '%U%B%d%b%u'
+
+zstyle ':completion:*:*:task:*' group-name ''
+
+alias t=task
+compdef _task t=task
diff --git a/plugins/textmate/textmate.plugin.zsh b/plugins/textmate/textmate.plugin.zsh
index 7b73e2751..aa2f75f4f 100644
--- a/plugins/textmate/textmate.plugin.zsh
+++ b/plugins/textmate/textmate.plugin.zsh
@@ -1,11 +1,9 @@
+alias et='mate .'
+alias ett='mate app config lib db public spec test Rakefile Capfile Todo'
+alias etp='mate app config lib db public spec test vendor/plugins vendor/gems Rakefile Capfile Todo'
+alias etts='mate app config lib db public script spec test vendor/plugins vendor/gems Rakefile Capfile Todo'
-# TextMate
-alias et='mate . &'
-alias ett='mate app config lib db public spec test Rakefile Capfile Todo &'
-alias etp='mate app config lib db public spec test vendor/plugins vendor/gems Rakefile Capfile Todo &'
-alias etts='mate app config lib db public script spec test vendor/plugins vendor/gems Rakefile Capfile Todo &'
-
-# Editor Ruby file in TextMate
+# Edit Ruby app in TextMate
alias mr='mate CHANGELOG app config db lib public script spec test'
function tm() {
diff --git a/plugins/thor/_thor b/plugins/thor/_thor
new file mode 100644
index 000000000..9f7ed5aef
--- /dev/null
+++ b/plugins/thor/_thor
@@ -0,0 +1,4 @@
+#compdef thor
+#autoload
+
+compadd `thor list | grep thor | cut -d " " -f 2`